#define _WIN32_IE 0x0400

#include <windows.h>
#include <richedit.h>
#include <commctrl.h>
#include <stdio.h>
#include "akelpad.h"
#include "edit.h"

extern HINSTANCE hInstance;
extern HWND hMainWnd;
extern int nCmdShow;
extern HMENU hMenu;
extern HWND hDlgModeless;
extern HWND hStatus;
extern BOOL bModified;
extern OPENFILENAME ofn;
extern char APP_SHORT_TITLE[];
extern char szLangModule[];
extern char buf[];
extern char buf2[];
extern HMODULE hLangLib;
extern LANGID wSystemLanguage;
extern int nLangModules;
extern BOOL bKeepOn;
extern BOOL bNeedAutodetect;
extern BOOL bOpenInNewWindow;
extern BOOL bUnixNewLine;
extern BOOL bModified;
extern int nPosition;
extern CHARRANGE chrg;
extern int nCurrentCodePage;
extern int nAnsiCodePage;
extern int nOemCodePage;

HINSTANCE hInstance;
LPSTR lpCmdLine;
int nCmdShow;
STARTUPINFO lpStartupInfo; 

char APP_SHORT_TITLE[]="AkelPad";
char szLangModule[MAX_PATH];
char buf[TEMP_BUFFER_SIZE];
char buf2[TEMP_BUFFER_SIZE];
HMODULE hLangLib;
LANGID wSystemLanguage;
int nLangModules=0;
UINT uiOpenOnStartMessage;
HWND hMainWnd;
HWND hSyncWindow;
HWND hStatus;
HWND hDlgModeless=NULL;
BOOL bInsertstate=TRUE;
BOOL bGlobalPrint=FALSE;
int nMaxChars=0x0FFFFFFF;
int nMcstep=0x0FFFFFFF;
RECT lpMainWindowRect;
BOOL (WINAPI *GetCPInfoExPtr) (UINT,DWORD,LPCPINFOEX);

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK DummyWndProc(HWND,UINT,WPARAM,LPARAM);

void _WinMain()
{
  HACCEL hAccel;
  MSG msg;
  WNDCLASS wndclass={0};
  WNDCLASS dummyclass={0};
  BOOL msgstatus;
  HMODULE hKernel32=0;
  HMODULE hRTFLib=0;
  HMENU hLangMenu;

  //Get standart WinMain info, because of own entry point.
  hInstance=GetModuleHandle(NULL);

  lpCmdLine=GetCommandLine();
  if (*lpCmdLine++ == '\"')
    while (*lpCmdLine != '\"' && *lpCmdLine != '\0') ++lpCmdLine;
  else
    while (*lpCmdLine != ' ' && *lpCmdLine != '\0') ++lpCmdLine;
  if (*lpCmdLine != '\0')
    while (*++lpCmdLine == ' ');

  lpStartupInfo.cb=sizeof(STARTUPINFO);
  GetStartupInfo(&lpStartupInfo);
  nCmdShow=lpStartupInfo.wShowWindow;

  hKernel32=LoadLibrary("kernel32.dll");
  GetCPInfoExPtr=(int(WINAPI *)(UINT,DWORD,LPCPINFOEX))GetProcAddress(hKernel32,"GetCPInfoExA");

  wSystemLanguage=GetUserDefaultLangID();
  RestorePreOptionsFromRegistry();

  if (*szLangModule)
  {
    if (!(hLangLib=LoadLibrary(szLangModule)))
    {
      hLangLib=hInstance;
      API_LoadString(hLangLib, MSG_ERROR_LOADING_LANG_DLL, buf, TEMP_BUFFER_SIZE);
      wsprintf(buf2, buf, szLangModule);
      MessageBox(NULL,buf2,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
    }
  }
  else hLangLib=hInstance;

  if (!(hRTFLib=LoadLibrary("RICHED20.DLL")))
  {
    API_LoadString(hLangLib, MSG_ERROR_LOADING_RICHEDIT_DLL, buf, TEMP_BUFFER_SIZE);
    MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
    goto Quit;
  }

  uiOpenOnStartMessage=RegisterWindowMessage("AkelPad Open-On-Start message");
  InitCommonControls();
  API_LoadString(hLangLib, STR_APP_FULL_TITLE, buf, TEMP_BUFFER_SIZE);

  wndclass.style        =CS_HREDRAW|CS_VREDRAW;
  wndclass.lpfnWndProc  =WndProc;
  wndclass.cbClsExtra   =0;
  wndclass.cbWndExtra   =DLGWINDOWEXTRA;
  wndclass.hInstance    =hInstance;
  wndclass.hIcon        =API_LoadIcon(hLangLib,MAKEINTRESOURCE(IDI_ICON1));
  wndclass.hCursor      =API_LoadCursor(hLangLib, IDC_ARROW);
  wndclass.hbrBackground=(HBRUSH)GetStockObject(HOLLOW_BRUSH);
  wndclass.lpszMenuName =MAKEINTRESOURCE(IDM_APPMENU);
  wndclass.lpszClassName=buf;
  if (!RegisterClass(&wndclass)) goto Quit;

  API_LoadString(hLangLib, STR_DUMMY_NAME, buf2, TEMP_BUFFER_SIZE);
  dummyclass.style        =0;
  dummyclass.lpfnWndProc  =DummyWndProc;
  dummyclass.cbClsExtra   =0;
  dummyclass.cbWndExtra   =DLGWINDOWEXTRA;
  dummyclass.hInstance    =hInstance;
  dummyclass.hIcon        =LoadIcon(NULL,IDI_APPLICATION);
  dummyclass.hCursor      =LoadCursor(NULL, IDC_ARROW);
  dummyclass.hbrBackground=(HBRUSH)GetStockObject(HOLLOW_BRUSH);
  dummyclass.lpszMenuName =NULL;
  dummyclass.lpszClassName=buf2;
  if (!RegisterClass(&dummyclass)) goto Quit;

  RestorePreOptionsFromRegistry();
  hLangMenu=API_LoadMenu(hLangLib, MAKEINTRESOURCE(IDM_APPMENU));

  hMainWnd=CreateWindow(buf,                      // window class name
                    APP_SHORT_TITLE,              // window caption
                    WS_OVERLAPPEDWINDOW,          // window style
                    lpMainWindowRect.left,        // initial x position
                    lpMainWindowRect.top,         // initial y position
                    lpMainWindowRect.right,       // initial x size
                    lpMainWindowRect.bottom,      // initial y size
                    NULL,                         // parent window handle
                    hLangMenu,                    // window menu handle
                    hInstance,                    // program instance handle
                    NULL);                        // creation parameters
  if (!hMainWnd) goto Quit;

  hSyncWindow=CreateWindow(buf2,                  // window class name
                           "",                    // window caption
                           WS_POPUP,              // window style
                           CW_USEDEFAULT,         // initial x position
                           CW_USEDEFAULT,         // initial y position
                           CW_USEDEFAULT,         // initial x size
                           CW_USEDEFAULT,         // initial y size
                           hMainWnd,              // parent window handle
                           NULL,                  // window menu handle
                           hInstance,             // program instance handle
                           NULL);                 // creation parameters

  hAccel=API_LoadAccelerators(hLangLib,MAKEINTRESOURCE(IDM_APPMENU));
  UpdateWindow(hMainWnd);

  while ((msgstatus=GetMessage(&msg,NULL,0,0)) && msgstatus != -1)
  {
    if (hDlgModeless == (HWND)NULL || !IsDialogMessage(hDlgModeless,&msg))
    {
      if (!TranslateAccelerator(hMainWnd,hAccel,&msg))
      {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
      }
    }
  }
  if (msgstatus == -1)
  {
    API_LoadString(hLangLib, MSG_ERROR_IN_MESSAGE_QUEUE, buf, TEMP_BUFFER_SIZE);
    MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
  }

  Quit:
  if (hRTFLib) FreeLibrary(hRTFLib);
  if (hLangLib) FreeLibrary(hLangLib);
  if (hKernel32) FreeLibrary(hKernel32);
  ExitProcess(0);
}

LRESULT CALLBACK WndProc(HWND hMainWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndEdit;
  static HMENU hPopup;
  static int iSBParts[]={110,210,310,-1};
  RECT ClientRect,StatusRect;
  LPARAM lMenuState;
  DWORD dwLong;
  POINT point;
  char *pCmdLine=lpCmdLine;
  char *pCmdFile=&ofn.lpstrFile[0];
  char *p;
  int line,column;
  HWND hWndFriend;

  if (message == uiOpenOnStartMessage)
  {
    RestoreOptionsFromRegistry(hWndEdit);
    SetModify(FALSE);
    if (*pCmdLine)
    {
      if (pCmdLine[0] == '/' && (pCmdLine[1] == 'p' || pCmdLine[1] == 'P'))
      {
        bGlobalPrint=TRUE;
        pCmdLine+=2;

        while (*pCmdLine == ' ') ++pCmdLine;
      }
      if (*pCmdLine == '\"')
      {
        lstrcpyn(ofn.lpstrFile,pCmdLine + 1,MAX_PATH);
        while (*pCmdFile != '\"' && *pCmdFile != '\0') ++pCmdFile;
      }
      else
      {
        lstrcpyn(ofn.lpstrFile,pCmdLine,MAX_PATH);
        while (*pCmdFile != ' ' && *pCmdFile != '\0') ++pCmdFile;
      }
      if (*pCmdFile != '\0') *pCmdFile='\0';

      if (!bOpenInNewWindow && GetFullPathName(ofn.lpstrFile,MAX_PATH,buf,&p))
      {
        API_LoadString(hLangLib, STR_DUMMY_NAME, buf2, TEMP_BUFFER_SIZE);
        if ((hWndFriend=FindWindow(buf2,buf)) && (hWndFriend=GetParent(hWndFriend)))
        {
          SetForegroundWindow(hWndFriend);
          PostQuitMessage(0);
          return 0;
        }
      }
      ShowWindow(hMainWnd,nCmdShow);

      bNeedAutodetect=TRUE;
      OpenDocument(hWndEdit);
      bNeedAutodetect=FALSE;
    }
    else ShowWindow(hMainWnd,nCmdShow);

    return 0;
  }

  switch(message)
  {
    case WM_CREATE:
      hMenu=GetMenu(hMainWnd);
      hPopup=API_LoadMenu(hLangLib,MAKEINTRESOURCE(IDM_POPUP));
      hPopup=GetSubMenu(hPopup,0);

      GetClientRect(hMainWnd, &ClientRect);

      hStatus=CreateWindow(STATUSCLASSNAME,
                           "",
                           WS_CHILD|WS_VISIBLE|SBARS_SIZEGRIP,
                           0,0,0,0,
                           hMainWnd,
                           (HMENU)ID_STATUS,
                           ((LPCREATESTRUCT)lParam)->hInstance,
                           NULL);

      API_LoadString(hLangLib, STR_MODE_INSERT, buf, TEMP_BUFFER_SIZE);
      SendMessage(hStatus,SB_SIMPLE,FALSE,0);
      SendMessage(hStatus,SB_SETPARTS,4,(LPARAM)&iSBParts);
      SendMessage(hStatus,SB_SETTEXT,0,(LPARAM)"1:1");
      SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)buf);
      SendMessage(hStatus,SB_SETTEXT,2,(LPARAM)"");
      DisplayCodePage(nAnsiCodePage);

      hWndEdit=CreateWindow("richedit20a",
                            NULL,
                            WS_CHILD|WS_VISIBLE|WS_HSCROLL|WS_VSCROLL|
                              ES_LEFT|ES_MULTILINE|WS_BORDER|
                              ES_AUTOHSCROLL|ES_AUTOVSCROLL|
                              ES_DISABLENOSCROLL|ES_SUNKEN|ES_NOHIDESEL,
                            0,
                            0,
                            ClientRect.right-ClientRect.left,
                            ClientRect.bottom-ClientRect.top,
                            hMainWnd,
                            (HMENU)ID_EDIT,
                            ((LPCREATESTRUCT)lParam)->hInstance,
                            NULL);

      SendMessage(hWndEdit,EM_EXLIMITTEXT,0,nMaxChars);

      InitEditor(hWndEdit);

      ShowWindow(hMainWnd,SW_HIDE);

      DragAcceptFiles(hMainWnd,TRUE);

      PostMessage(hMainWnd,uiOpenOnStartMessage,0,0);
      break;

    case WM_INITMENU:
      LanguageMenu(hWndEdit);
    case WM_MENUSELECT:
    case WM_INITMENUPOPUP:
      //Check if any file is opened
      EnableMenuItem(hMenu,IDM_FILE_REOPEN,(*ofn.lpstrFile)?MF_ENABLED:MF_GRAYED);
      //Check if "Save" option should be enabled
      EnableMenuItem(hMenu,IDM_FILE_SAVE,(GetModify() || !ofn.lpstrFile[0])?MF_ENABLED:MF_GRAYED);

      //Check if the selection is empty
      if (chrg.cpMin == chrg.cpMax) lMenuState=MF_GRAYED;
      else lMenuState=MF_ENABLED;
      EnableMenuItem(hMenu,IDM_EDIT_CUT,lMenuState);
      EnableMenuItem(hMenu,IDM_EDIT_COPY,lMenuState);
      EnableMenuItem(hMenu,IDM_EDIT_CLEAR,lMenuState);
      EnableMenuItem(hMenu,IDM_EDIT_UPPERCASE,lMenuState);
      EnableMenuItem(hMenu,IDM_EDIT_LOWERCASE,lMenuState);
      EnableMenuItem(hMenu,IDM_EDIT_SENTENCECASE,lMenuState);
      EnableMenuItem(hMenu,IDM_EDIT_TITLECASE,lMenuState);
      EnableMenuItem(hMenu,IDM_EDIT_INVERTCASE,lMenuState);

      if (!DoEditInsertCharInSelection(hWndEdit, CHECK_STATE, 0)) lMenuState=MF_GRAYED;
      else lMenuState=MF_ENABLED;
      EnableMenuItem(hMenu,IDM_EDIT_INSERT_TAB_MENU,lMenuState);
      EnableMenuItem(hMenu,IDM_EDIT_DELETE_TAB_MENU,lMenuState);
      EnableMenuItem(hMenu,IDM_EDIT_INSERT_SPACE_MENU,lMenuState);
      EnableMenuItem(hMenu,IDM_EDIT_DELETE_SPACE_MENU,lMenuState);

      if (!DoEditDeleteTrailingWhitespaces(hWndEdit, CHECK_TRAILING_WHITESPACES)) lMenuState=MF_GRAYED;
      else lMenuState=MF_ENABLED;
      EnableMenuItem(hMenu,IDM_EDIT_DELETE_TRAILING_WHITESPACES_MENU,lMenuState);

      //Check if paste, undo, redo is allowed
      EnableMenuItem(hMenu,IDM_EDIT_UNDO,SendMessage(hWndEdit,EM_CANUNDO,0,0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMenu,IDM_EDIT_REDO,(SendMessage(hWndEdit,EM_CANREDO,0,0))?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMenu,IDM_EDIT_PASTE,SendMessage(hWndEdit,EM_CANPASTE,0,0)?MF_ENABLED:MF_GRAYED);

      //Set up Windows/Unix newline format selection
      if (bUnixNewLine)
      {
        CheckMenuItem(hMenu,IDM_CODEPAGE_NEWLINE_UNIX,MF_CHECKED);
        CheckMenuItem(hMenu,IDM_CODEPAGE_NEWLINE_WIN,MF_UNCHECKED);
      }
      else
      {
        CheckMenuItem(hMenu,IDM_CODEPAGE_NEWLINE_UNIX,MF_UNCHECKED);
        CheckMenuItem(hMenu,IDM_CODEPAGE_NEWLINE_WIN,MF_CHECKED);
      }
      return 0;

    case WM_SETFOCUS:
      SetFocus(hWndEdit);
      return 0;

    case WM_SIZE:
      SendMessage(hStatus,WM_SIZE,wParam,lParam);
      GetWindowRect(hStatus, &StatusRect);
      MoveWindow(hWndEdit,0,0,LOWORD(lParam),HIWORD(lParam)-(StatusRect.bottom-StatusRect.top),TRUE);
      return 0;

    case WM_DROPFILES:
      if (DoFileNew(hWndEdit))
      {
        DragQueryFile((HDROP)wParam,0,ofn.lpstrFile,MAX_PATH);
        bNeedAutodetect=TRUE;
        OpenDocument(hWndEdit);
        bNeedAutodetect=FALSE;
      }
      return 0;

    case WM_COMMAND:
      if (LOWORD(wParam) >= IDM_RECENT_FILES && LOWORD(wParam) < IDM_RECENT_FILES+RECENTFILES)
      {
        if (DoFileNew(hWndEdit))
        {
          GetMenuString(hMenu,LOWORD(wParam),ofn.lpstrFile,MAX_PATH,MF_BYCOMMAND);
          bNeedAutodetect=TRUE;
          OpenDocument(hWndEdit);
          bNeedAutodetect=FALSE;
        }
        return 0;
      }
      if (LOWORD(wParam) >= IDM_SETTINGS_LANGUAGE && LOWORD(wParam) <= IDM_SETTINGS_LANGUAGE+nLangModules+1)
      {
        if (LOWORD(wParam) == IDM_SETTINGS_LANGUAGE)
        {
          if (!*szLangModule) return 0;
          szLangModule[0]='\0';
        }
        else
        {
          GetMenuString(hMenu,LOWORD(wParam),buf,TEMP_BUFFER_SIZE,MF_BYCOMMAND);
          if (!lstrcmpi(szLangModule, buf)) return 0;
          lstrcpy(szLangModule, buf);
        }
        API_LoadString(hLangLib, MSG_RESTART_LANGUAGE, buf, TEMP_BUFFER_SIZE);
        MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_OK|MB_ICONEXCLAMATION);
        return 0;
      }

      switch(LOWORD(wParam))
      {
        case ID_EDIT:
          switch(HIWORD(wParam))
          {
            case EN_CHANGE:
              SetModify(TRUE);
              break;
            case EN_MAXTEXT:
              //trying to reallocate
              API_LoadString(hLangLib, MSG_ERROR_LIMIT_REACHED, buf, TEMP_BUFFER_SIZE);
              MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
              nMaxChars+=nMcstep;
              SendMessage(hWndEdit,EM_EXLIMITTEXT,0,nMaxChars);
              break;
            case EN_ERRSPACE:
              API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY_FOR_RICHEDIT, buf, TEMP_BUFFER_SIZE);
              MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
              ExitProcess(1);
              break;
          }
          break;
        case IDM_FILE_NEW:
          DoFileNew(hWndEdit);
          break;
        case IDM_FILE_CREATENEW:
          SaveOptionsInRegistry(hMainWnd);
          DoFileNewWindow(hWndEdit);
          break;
        case IDM_FILE_OPEN:
          DoFileOpen(hWndEdit);
          break;
        case IDM_FILE_REOPEN:
          DoFileReopen(hWndEdit);
          break;
        case IDM_FILE_SAVE:
          DoFileSave(hWndEdit);
          break;
        case IDM_FILE_SAVEAS:
          DoFileSaveAs(hWndEdit);
          break;
        case IDM_FILE_PAGESETUP:
          DoFilePageSetup(hWndEdit);
          break;
        case IDM_FILE_PRINT:
          DoFilePrint(hWndEdit);
          break;
        case IDM_FILE_EXIT:
          DoFileExit(hWndEdit);
          break;

        case IDM_EDIT_UNDO:
          DoEditUndo(hWndEdit);
          break;
        case IDM_EDIT_REDO:
          DoEditRedo(hWndEdit);
          break;
        case IDM_EDIT_CUT:
          DoEditCut(hWndEdit);
          break;
        case IDM_EDIT_COPY:
          DoEditCopy(hWndEdit);
          break;
        case IDM_EDIT_PASTE:
          DoEditPaste(hWndEdit);
          break;
        case IDM_EDIT_CLEAR:
          DoEditClear(hWndEdit);
          break;
        case IDM_EDIT_SELECTALL:
          DoEditSelectAll(hWndEdit);
          break;
        case IDM_EDIT_INSERTCHAR:
          DoEditInsertChar(hWndEdit);
          break;
        case IDM_EDIT_INSERT_TAB_MENU:
        case IDM_EDIT_INSERT_TAB:
          DoEditInsertCharInSelection(hWndEdit, CHAR_INSERT, '\t');
          break;
        case IDM_EDIT_DELETE_TAB_MENU:
        case IDM_EDIT_DELETE_TAB:
          DoEditInsertCharInSelection(hWndEdit, CHAR_DELETE, '\t');
          break;
        case IDM_EDIT_INSERT_SPACE_MENU:
        case IDM_EDIT_INSERT_SPACE:
          DoEditInsertCharInSelection(hWndEdit, CHAR_INSERT, ' ');
          break;
        case IDM_EDIT_DELETE_SPACE_MENU:
        case IDM_EDIT_DELETE_SPACE:
          DoEditInsertCharInSelection(hWndEdit, CHAR_DELETE, ' ');
          break;
        case IDM_EDIT_DELETE_TRAILING_WHITESPACES_MENU:
        case IDM_EDIT_DELETE_TRAILING_WHITESPACES:
          DoEditDeleteTrailingWhitespaces(hWndEdit, DELETE_TRAILING_WHITESPACES);
          break;
        case IDM_EDIT_UPPERCASE:
          DoEditChangeCase(hWndEdit, UPPERCASE);
          break;
        case IDM_EDIT_LOWERCASE:
          DoEditChangeCase(hWndEdit, LOWERCASE);
          break;
        case IDM_EDIT_SENTENCECASE:
          DoEditChangeCase(hWndEdit, SENTENCECASE);
          break;
        case IDM_EDIT_TITLECASE:
          DoEditChangeCase(hWndEdit, TITLECASE);
          break;
        case IDM_EDIT_INVERTCASE:
          DoEditChangeCase(hWndEdit, INVERTCASE);
          break;
        case IDM_EDIT_WRAP:
          DoEditWrap(hWndEdit);
          break;
        case IDM_EDIT_KEEPSPACE:
          DoEditKeepSpace(hWndEdit);
          break;

        case IDM_SEARCH_FIND:
          DoSearchFind(hWndEdit);
          break;
        case IDM_SEARCH_FINDNEXTDOWN:
          DoSearchFindNextDown(hWndEdit);
          break;
        case IDM_SEARCH_FINDNEXTUP:
          DoSearchFindNextUp(hWndEdit);
          break;
        case IDM_SEARCH_REPLACE:
          DoSearchReplace(hWndEdit);
          break;
        case IDM_SEARCH_GOTOLINE:
          DoSearchGoToLine(hWndEdit);
          break;

        case IDM_SETTINGS_FONT:
          DoSettingsFont(hWndEdit);
          break;
        case IDM_SETTINGS_BG:
          DoSettingsBG(hWndEdit);
          break;
        case IDM_SETTINGS_SAVETIME:
          DoSettingsSaveTime(hWndEdit);
          break;
        case IDM_SETTINGS_NOMULTIOPEN:
          DoSettingsNoMultiOpen(hWndEdit);
          SaveOptionsInRegistry(hMainWnd);
          break;
        case IDM_SETTINGS_ONTOP:
          DoSettingsOnTop(hWndEdit);
          break;

        case IDM_CODEPAGE_OPENAS_ANSI:
          DoCodePageOpenAs(hWndEdit, nAnsiCodePage);
          break;
        case IDM_CODEPAGE_OPENAS_OEM:
          DoCodePageOpenAs(hWndEdit, nOemCodePage);
          break;
        case IDM_CODEPAGE_OPENAS_KOI:
          DoCodePageOpenAs(hWndEdit, KOI8_R);
          break;
        case IDM_CODEPAGE_OPENAS_UNICODE_UCS2_LE:
          DoCodePageOpenAs(hWndEdit, CP_UNICODE_UCS2_LE);
          break;
        case IDM_CODEPAGE_OPENAS_UNICODE_UCS2_BE:
          DoCodePageOpenAs(hWndEdit, CP_UNICODE_UCS2_BE);
          break;
        case IDM_CODEPAGE_OPENAS_UNICODE_UTF8:
          DoCodePageOpenAs(hWndEdit, CP_UNICODE_UTF8);
          break;
        case IDM_CODEPAGE_OPENAS:
          DoCodePageOpenAs(hWndEdit, DoSelectCodePage(hMainWnd));
          break;
        case IDM_CODEPAGE_SAVEIN_ANSI:
          DoCodePageSaveIn(hWndEdit, nAnsiCodePage);
          break;
        case IDM_CODEPAGE_SAVEIN_OEM:
          DoCodePageSaveIn(hWndEdit, nOemCodePage);
          break;
        case IDM_CODEPAGE_SAVEIN_KOI:
          DoCodePageSaveIn(hWndEdit, KOI8_R);
          break;
        case IDM_CODEPAGE_SAVEIN_UNICODE_UCS2_LE:
          DoCodePageSaveIn(hWndEdit, CP_UNICODE_UCS2_LE);
          break;
          case IDM_CODEPAGE_SAVEIN_UNICODE_UCS2_BE:
          DoCodePageSaveIn(hWndEdit, CP_UNICODE_UCS2_BE);
          break;
        case IDM_CODEPAGE_SAVEIN_UNICODE_UTF8:
          DoCodePageSaveIn(hWndEdit, CP_UNICODE_UTF8);
          break;
        case IDM_CODEPAGE_SAVEIN:
          DoCodePageSaveIn(hWndEdit, DoSelectCodePage(hMainWnd));
          break;
        case IDM_CODEPAGE_NEWLINE_UNIX:
          if (!bUnixNewLine) SetModify(TRUE);
          bUnixNewLine=TRUE;
          break;
        case IDM_CODEPAGE_NEWLINE_WIN:
          if (bUnixNewLine) SetModify(TRUE);
          bUnixNewLine=FALSE;
          break;

        case IDM_HELP_ABOUT:
          DoHelpAbout(hWndEdit);
          break;

        case IDM_NONMENU_CHANGESIZE:
          dwLong=GetWindowLong(hMainWnd,GWL_STYLE);
          if (dwLong&WS_MAXIMIZE) ShowWindow(hMainWnd,SW_RESTORE);
          else ShowWindow(hMainWnd,SW_MAXIMIZE);
          break;
        case IDM_NONMENU_DELLINE:
          DoNonMenuDelLine(hWndEdit);
          break;
      }
      return 0;

    case WM_NOTIFY:
      //Some unmaintainable code is here
      if (wParam == ID_STATUS)
      {
        if (((LPNMHDR)lParam)->code == NM_CLICK)
        {
          switch(((LPNMMOUSE)lParam)->dwItemSpec)
          {
          case 1:
            SendMessage(hWndEdit,WM_KEYDOWN,VK_INSERT,0x00520001);
            SendMessage(hWndEdit,WM_KEYUP,VK_INSERT,0xC0520001);
            break;
          case 0:
            DoSearchGoToLine(hWndEdit);
            break;
          }
        }
      }
      else if (wParam == ID_EDIT)
      {
        if (((LPNMHDR)lParam)->code == EN_SELCHANGE)
        {
          CHARRANGE cr;
          int linebreaks=0;

          SendMessage(hWndEdit,EM_EXGETSEL,0,(LPARAM)&cr);
          if (cr.cpMin == chrg.cpMin || cr.cpMin == chrg.cpMax) nPosition=cr.cpMax;
          else nPosition=cr.cpMin;

          chrg.cpMin=cr.cpMin;
          chrg.cpMax=cr.cpMax;

          line=SendMessage(hWndEdit,EM_EXLINEFROMCHAR,0,nPosition)+1;
          column=SendMessage(hWndEdit,EM_LINEINDEX,line-1,0); //column=index of first character in that string
          column=nPosition-column+1;

          if (chrg.cpMin == chrg.cpMax)
          {
            wsprintf(buf,"%u:%u",line,column);
          }
          else
          {
            if (!bUnixNewLine) linebreaks=SendMessage(hWndEdit,EM_EXLINEFROMCHAR,0,chrg.cpMax)-SendMessage(hWndEdit,EM_EXLINEFROMCHAR,0,chrg.cpMin);
            wsprintf(buf,"%u:%u,%u",line,column,chrg.cpMax-chrg.cpMin+linebreaks);
          }
          SendMessage(hStatus,SB_SETTEXT,0,(LPARAM)buf);
        }
        else if (((LPNMHDR)lParam)->code == EN_MSGFILTER) //Space-keeping mode and other related stuff
        {
          if (((MSGFILTER *)lParam)->msg == WM_KEYDOWN && ((MSGFILTER *)lParam)->wParam == VK_RETURN && bKeepOn)
          {
            TEXTRANGE txtrng;
            int minline;
            int minlineindex;
            int textsize;
            int a;
            char *pText;

            minline=SendMessage(hWndEdit,EM_LINEFROMCHAR,chrg.cpMin,0);
            minlineindex=SendMessage(hWndEdit,EM_LINEINDEX,minline,0);
            txtrng.chrg.cpMin=minlineindex;
            txtrng.chrg.cpMax=chrg.cpMin;
            textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin;

            if (textsize)
            {
              if (pText=(char *)HeapAlloc(GetProcessHeap(),0,textsize + 2))
              {
                txtrng.lpstrText=pText + 1;
                SendMessage(hWndEdit,EM_GETTEXTRANGE,0,(LPARAM)&txtrng);
  
                for (a=1, pText[0]='\n'; pText[a] == ' ' || pText[a] == '\t'; ++a);

                pText[a]='\0';
              }
              else
              {
                API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY, buf, TEMP_BUFFER_SIZE);
                MessageBox(NULL,buf,NULL,MB_OK|MB_ICONERROR);
              }

              SendMessage(hWndEdit,EM_REPLACESEL,TRUE,(LPARAM)pText);
              HeapFree(GetProcessHeap(),0,(LPVOID)pText);
              return -1;
            }
          }
          else if (((MSGFILTER *)lParam)->msg == WM_KEYDOWN && ((MSGFILTER *)lParam)->wParam == VK_INSERT)
          {
            if (GetKeyState(VK_SHIFT) >= 0 && GetKeyState(VK_CONTROL) >= 0)
            {
              bInsertstate=!bInsertstate;
              API_LoadString(hLangLib, STR_MODE_INSERT, buf, TEMP_BUFFER_SIZE);
              API_LoadString(hLangLib, STR_MODE_OVERLAP, buf2, TEMP_BUFFER_SIZE);
              SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)(bInsertstate?buf:buf2));
            }
          }
          else if (((MSGFILTER *)lParam)->msg == WM_RBUTTONUP || ((MSGFILTER *)lParam)->msg == WM_KEYDOWN && ((MSGFILTER *)lParam)->wParam == VK_APPS)
          {
            if (((MSGFILTER *)lParam)->msg == WM_RBUTTONUP)
            {
              point.x=LOWORD(((MSGFILTER *)lParam)->lParam);
              point.y=HIWORD(((MSGFILTER *)lParam)->lParam);
            }
            else
            {
              point.x=0;
              point.y=0;
            }
            ClientToScreen(hMainWnd,&point);

            //Check if the selection is empty
            if (chrg.cpMin == chrg.cpMax) lMenuState=MF_GRAYED;
            else lMenuState=MF_ENABLED;
            EnableMenuItem(hPopup,IDM_EDIT_CUT,lMenuState);
            EnableMenuItem(hPopup,IDM_EDIT_COPY,lMenuState);
            EnableMenuItem(hPopup,IDM_EDIT_CLEAR,lMenuState);

            //Check if paste, undo, redo is allowed
            EnableMenuItem(hPopup,IDM_EDIT_UNDO,SendMessage(hWndEdit,EM_CANUNDO,0,0)?MF_ENABLED:MF_GRAYED);
            EnableMenuItem(hPopup,IDM_EDIT_REDO,SendMessage(hWndEdit,EM_CANREDO,0,0)?MF_ENABLED:MF_GRAYED);
            EnableMenuItem(hPopup,IDM_EDIT_PASTE,SendMessage(hWndEdit,EM_CANPASTE,0,0)?MF_ENABLED:MF_GRAYED);

            TrackPopupMenu(hPopup,
                           TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,
                           point.x,
                           point.y,
                           0,
                           hMainWnd,
                           NULL);
            return -1;
          }
        }
      }
      return 0;

    case WM_CLOSE:
      DoFileExit(hWndEdit);
      return 0;

    case WM_DESTROY:
      if (hWndEdit) DestroyWindow(hWndEdit);
      SaveOptionsInRegistry(hMainWnd);
      FreeMemory();
      PostQuitMessage(0);
      return 0;
  }

  return DefWindowProc(hMainWnd,message,wParam,lParam);
}

LRESULT CALLBACK DummyWndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
  if (message == WM_CREATE)
  {
    ShowWindow(hWnd,SW_HIDE);
    return 0;
  }
  return DefWindowProc(hWnd,message,wParam,lParam);
}
