#include <windows.h>
#include <richedit.h>
#include <commctrl.h>
#include <stdio.h>
#include <wchar.h>
#include "akelpad.h"
#include "edit.h"

#define xatoi
#define hex2dec
#include "ConvFunc.h"

extern HINSTANCE hInstance;
extern HWND hMainWnd;
extern int nCmdShow;
extern HWND hDlgModeless;
extern HWND hSyncWindow;
extern HWND hStatus;
extern RECT lpMainWindowRect;
extern BOOL bGlobalPrint;
extern char APP_SHORT_TITLE[];
extern char szLangModule[];
extern char buf[];
extern char buf2[];
extern HMODULE hLangLib;
extern LANGID wSystemLanguage;
extern int nLangModules;
extern int nCurrentCodePage;
extern int nAnsiCodePage;
extern int nOemCodePage;
extern BOOL (WINAPI *GetCPInfoExPtr) (UINT,DWORD,LPCPINFOEX);

CHARRANGE chrg;
int nPosition;
HMENU hMenu;
BOOL bAppendHeader=TRUE; //whether header was in last translated text
BOOL bUnixNewLine=FALSE; //Unix newline (0x0A) was detected when opening file
BOOL bNewLineDetected=FALSE;
char szRecentNames[RECENTFILES][MAX_PATH+1]; //names of recent files
DWORD szRecentPositions[RECENTFILES]; //positions in recent files
OPENFILENAME ofn;
char szFileBuffer[MAX_PATH+1]; //placeholder for ofn.lpstrFile
unsigned char pcReadBuffer[READBUFFERSIZE];
unsigned char pcTranslateBuffer[TRANSLATEBUFFERSIZE];
HFONT hCurrentFont=NULL;
CHOOSEFONT cf;
CHOOSECOLOR cc;
LOGFONT logfont;
LOGFONT logfont2;
BOOL bUseSystemBckgColor=TRUE;
PAGESETUPDLG psdPage;
PRINTDLG pd;
FINDTEXTEX ft;
DWORD ftflags=0;
BOOL bReplaceDlg;
char *org_query;
char *org_replace;
int nReplaceCount;
BOOL bWrapOn=FALSE;           //wrap strings
BOOL bKeepOn=FALSE;           //keep left space
BOOL bNeedAutodetect=FALSE;   //if charset should be auto-detected
BOOL bSaveTime=FALSE;
BOOL bOpenInNewWindow=TRUE;
BOOL bOnTop=FALSE;
BOOL bModified=FALSE;
BOOL firsttime;
BOOL bFirstFindReplace=TRUE;
BOOL bFirstWordBreak=TRUE;
char szSentenceSelimiters[ARRAY_SIZE]=".\r\n";
char szTitleDelimiters[ARRAY_SIZE]=" \t\r\n";
wchar_t wszDelimiters[ARRAY_SIZE]=L"[](){}<>,.;:+-=~!@#$%^&*?/\\'`\"|";
wchar_t wszWhitespace[]=L" \t";
wchar_t wszLinebreakers[]=L"\r\n";
int nDialogCP;
BOOL codepages[65536];
int nCurrentCodePage;
int nAnsiCodePage;
int nOemCodePage;

typedef struct _GLOBALDATA {
  unsigned char *pData;
  int nLength;
} GLOBALDATA;

void InitEditor(HWND hWndEdit)
{
  COLORREF crCustColors[16];
  char szFilter[MAX_PATH];
  int nLangoptions;
  int i;

  nLangoptions=SendMessage(hWndEdit, EM_GETLANGOPTIONS, 0, 0);
  nLangoptions&=~IMF_AUTOFONT;
  nLangoptions&=~IMF_AUTOFONTSIZEADJUST;
  SendMessage(hWndEdit, EM_SETLANGOPTIONS, 0, nLangoptions);
  SendMessage(hWndEdit,EM_SETTEXTMODE,TM_RICHTEXT|TM_MULTILEVELUNDO|TM_MULTICODEPAGE,0);
  SendMessage(hWndEdit,EM_SETWORDBREAKPROC,0,(LPARAM)(EDITWORDBREAKPROC)MyEditWordBreakProc);
  SendMessage(hWndEdit,EM_SETEVENTMASK,0,ENM_SELCHANGE|ENM_CHANGE|ENM_KEYEVENTS|ENM_MOUSEEVENTS);

  API_LoadString(hLangLib, STR_FILE_FILTER, szFilter, TEMP_BUFFER_SIZE);
  for (i=0; szFilter[i]; ++i)
    if (szFilter[i] == '|') szFilter[i]='\0';
  szFilter[++i]='\0';

  ofn.lpstrFile=(char *)&szFileBuffer;
  ofn.lpstrFile[0]='\0';
  ofn.lStructSize      =sizeof(OPENFILENAME);
  ofn.hwndOwner        =hMainWnd;
  ofn.hInstance        =NULL;
  ofn.lpstrFilter      =szFilter;
  ofn.lpstrCustomFilter=NULL;
  ofn.nMaxCustFilter   =0;
  ofn.nFilterIndex     =2;
  ofn.nMaxFile         =MAX_PATH;
  ofn.lpstrFileTitle   =NULL;
  ofn.nMaxFileTitle    =0;
  ofn.lpstrInitialDir  =NULL;
  ofn.lpstrTitle       =NULL;
  ofn.nFileOffset      =0;
  ofn.nFileExtension   =0;
  ofn.lCustData        =0;
  ofn.lpfnHook         =NULL;
  ofn.lpTemplateName   =NULL;

  cc.lStructSize=sizeof(CHOOSECOLOR);
  cc.hwndOwner=hMainWnd;
  cc.hInstance=0;
  cc.rgbResult=RGB(0xFF,0xFF,0xFF);
  cc.lpCustColors=crCustColors;
  cc.Flags=CC_FULLOPEN|CC_RGBINIT;
  cc.lCustData=0;
  cc.lpfnHook=NULL;
  cc.lpTemplateName=NULL;
  memset(crCustColors,0,16*sizeof(COLORREF));

  chrg.cpMin=chrg.cpMax=nPosition=1;

  org_query=NULL;
  org_replace=NULL;

  cf.lpLogFont=&logfont;
  cf.rgbColors=0;
  GetObject(GetStockObject(SYSTEM_FONT),sizeof(LOGFONT),&logfont);
  SetChosenFont(hWndEdit);

  RestoreLastFilePosition(hWndEdit);
  RecentFilesMenu(hWndEdit);

  memset(&psdPage,0,sizeof(PAGESETUPDLG));
  if (GetLocaleInfo(LOCALE_USER_DEFAULT,LOCALE_IMEASURE,buf,16))
  {
    if (*buf == '0')
    {
      psdPage.rtMargin.left=1000;
      psdPage.rtMargin.right=1000;
      psdPage.rtMargin.top=1000;
      psdPage.rtMargin.bottom=1000;
    }
    else
    {
      psdPage.rtMargin.left=500;
      psdPage.rtMargin.right=500;
      psdPage.rtMargin.top=500;
      psdPage.rtMargin.bottom=500;
    }
  }

  memset(&pd,0,sizeof(PRINTDLG));
  pd.Flags=PD_ALLPAGES|PD_NOPAGENUMS|PD_RETURNDC|PD_USEDEVMODECOPIESANDCOLLATE;
  pd.nCopies=1;

  nAnsiCodePage=GetACP();
  nOemCodePage=GetOEMCP();
  nCurrentCodePage=nAnsiCodePage;
}

BOOL DoFileNew(HWND hWndEdit)
{
  int nChoice;

  if (GetModify())
  {
    API_LoadString(hLangLib, MSG_DOCUMENT_CHANGED, buf, TEMP_BUFFER_SIZE);
    nChoice=MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_YESNOCANCEL|MB_ICONEXCLAMATION);

    if (nChoice == IDYES)
    {
      if (!DoFileSave(hWndEdit)) return FALSE;
    }
    else if (nChoice == IDCANCEL) return FALSE;
  }
  AddLastFilePosition(hWndEdit);
  RecentFilesMenu(hWndEdit);
  bUnixNewLine=FALSE;
  DisplayCodePage(nAnsiCodePage);
  HideCaret(NULL);
  SetWindowText(hWndEdit,"");
  ShowCaret(NULL);
  SetWindowText(hMainWnd,APP_SHORT_TITLE);
  ofn.lpstrFile[0]='\0';
  SetModify(FALSE);
  return TRUE;
}

void DoFileNewWindow(HWND hWndEdit)
{
  STARTUPINFO si;
  PROCESS_INFORMATION pi;

  memset(&si,0,sizeof(STARTUPINFO));
  si.cb=sizeof(STARTUPINFO);

  if (!GetModuleFileName(GetModuleHandle(NULL),buf,MAX_PATH)) return;

  CreateProcess(buf,NULL,NULL,NULL,FALSE,0,NULL,NULL,&si,&pi);
  CloseHandle(pi.hProcess);
  CloseHandle(pi.hThread);
}

void DoFileOpen(HWND hWndEdit)
{
  int nChoice;

  ofn.Flags=OFN_CREATEPROMPT|OFN_LONGNAMES|OFN_HIDEREADONLY;
  ofn.lpstrDefExt=NULL;

  if (GetModify())
  {
    API_LoadString(hLangLib, MSG_DOCUMENT_CHANGED, buf, TEMP_BUFFER_SIZE);
    nChoice=MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_YESNOCANCEL|MB_ICONEXCLAMATION);

    if (nChoice == IDYES)
    {
      if (!DoFileSave(hWndEdit)) return;
    }
    else if (nChoice == IDCANCEL) return;
  }

  if (GetOpenFileName(&ofn))
  {
    bNeedAutodetect=TRUE;
    OpenDocument(hWndEdit);
    bNeedAutodetect=FALSE;
  }
}

void DoFileReopen(HWND hWndEdit)
{
  if (!*ofn.lpstrFile) return;
  else if (!GetModify()) OpenDocument(hWndEdit);
  else
  {
    API_LoadString(hLangLib, MSG_FILE_WILL_BE_REOPENED, buf, TEMP_BUFFER_SIZE);
    if (MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_OKCANCEL|MB_ICONEXCLAMATION) == IDOK) OpenDocument(hWndEdit);
  }
}

BOOL DoFileSave(HWND hWndEdit)
{
  if (!GetModify() && *ofn.lpstrFile) return FALSE;
  if (!*ofn.lpstrFile) return DoFileSaveAs(hWndEdit);
  SaveDocument(hWndEdit);
  return TRUE;
}

BOOL DoFileSaveAs(HWND hWndEdit)
{
  ofn.Flags=OFN_OVERWRITEPROMPT|OFN_LONGNAMES|OFN_HIDEREADONLY;
  ofn.lpstrDefExt="txt";

  if (GetSaveFileName(&ofn))
  {
    SaveDocument(hWndEdit);
    return TRUE;
  }
  return FALSE;
}

void DoFilePageSetup(HWND hWndEdit)
{
  psdPage.lStructSize=sizeof(PAGESETUPDLG);
  psdPage.hwndOwner=hMainWnd;
  psdPage.Flags=PSD_MARGINS;

  PageSetupDlg(&psdPage);
}

void DoFilePrint(HWND hWndEdit)
{
  FORMATRANGE fr;
  DOCINFO di;
  int nextch;
  int width,height;

  pd.lStructSize=sizeof(PRINTDLG);
  pd.hwndOwner=hMainWnd;
  pd.hDevMode=psdPage.hDevMode;
  pd.hDevNames=psdPage.hDevNames;
  pd.Flags|=PD_NOPAGENUMS|PD_RETURNDC|PD_USEDEVMODECOPIESANDCOLLATE;

  memset(&di,0,sizeof(DOCINFO));

  API_LoadString(hLangLib, STR_DOCNAME, buf, TEMP_BUFFER_SIZE);
  di.cbSize=sizeof(DOCINFO);
  di.lpszDocName=(*ofn.lpstrFile)?ofn.lpstrFile:buf;

  if (!PrintDlg(&pd)) return;

  width=GetDeviceCaps(pd.hDC,HORZSIZE)*56; //about 56 twips per millimeter
  height=GetDeviceCaps(pd.hDC,VERTSIZE)*56;

  fr.hdc=pd.hDC;
  fr.hdcTarget=pd.hDC;

  if (psdPage.Flags&PSD_INHUNDREDTHSOFMILLIMETERS)
  {
    fr.rc.left=psdPage.rtMargin.left*567/1000;
    fr.rc.top=psdPage.rtMargin.top*567/1000;
    fr.rc.right=width-psdPage.rtMargin.right*567/1000;
    fr.rc.bottom=height-psdPage.rtMargin.bottom*567/1000;
  }
  else
  {
    fr.rc.left=psdPage.rtMargin.left*144/100;
    fr.rc.top=psdPage.rtMargin.top*144/100;
    fr.rc.right=width-psdPage.rtMargin.right*144/100;
    fr.rc.bottom=height-psdPage.rtMargin.bottom*144/100;
  }
  fr.rcPage.left=0;
  fr.rcPage.top=0;
  fr.rcPage.right=width;
  fr.rcPage.bottom=height;

  if (pd.Flags&PD_PRINTTOFILE) di.lpszOutput="FILE:";

  if (StartDoc(pd.hDC,&di) <= 0)
  {
    API_LoadString(hLangLib, MSG_ERROR_PRINT, buf, TEMP_BUFFER_SIZE);
    MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
    return;
  }

  if (pd.Flags&PD_SELECTION)
  {
    SendMessage(hWndEdit,EM_EXGETSEL,0,(LPARAM)&fr.chrg);
  }
  else
  {
    fr.chrg.cpMin=0;
    fr.chrg.cpMax=-1;
  }

  do
  {
    nextch=SendMessage(hWndEdit,EM_FORMATRANGE,FALSE,(LPARAM)&fr);
    if (nextch == fr.chrg.cpMin) break;
    fr.chrg.cpMin=nextch;
    StartPage(pd.hDC);
    if (!SendMessage(hWndEdit,EM_DISPLAYBAND,0,(LPARAM)&fr.rc))
    {
      EndPage(pd.hDC);
      API_LoadString(hLangLib, MSG_ERROR_PRINT, buf, TEMP_BUFFER_SIZE);
      MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
      break;
    }
    EndPage(pd.hDC);
  }
  while (true);

  EndDoc(pd.hDC);
  DeleteDC(pd.hDC);
}

void DoFileExit(HWND hWndEdit)
{
  int nChoice;

  if (GetModify())
  {
    API_LoadString(hLangLib, MSG_DOCUMENT_CHANGED, buf, TEMP_BUFFER_SIZE);
    nChoice=MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_YESNOCANCEL|MB_ICONEXCLAMATION);

    if (nChoice == IDYES)
    {
      if (!DoFileSave(hWndEdit)) return;
    }
    else if (nChoice == IDCANCEL) return;
  }
  AddLastFilePosition(hWndEdit);
  SaveLastFilePosition(hWndEdit);
  DestroyWindow(hMainWnd);
}

void DoEditUndo(HWND hWndEdit)
{
  SendMessage(hWndEdit,EM_UNDO,0,0);
}

void DoEditRedo(HWND hWndEdit)
{
  SendMessage(hWndEdit,EM_REDO,0,0);
}

void DoEditCut(HWND hWndEdit)
{
  SendMessage(hWndEdit,WM_CUT,0,0);
}

void DoEditCopy(HWND hWndEdit)
{
  SendMessage(hWndEdit,WM_COPY,0,0);
}

DWORD CALLBACK PasteCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
  //Paste operation based on Krzysztof Foltman code
  GLOBALDATA *lpData=(GLOBALDATA *)dwCookie;
  WORD *pSrc=(WORD *)lpData->pData;
  WORD *pDest=(WORD *)pbBuff;
  int i;

  for (i=0, cb>>=1; i < cb && pSrc[lpData->nLength]; ++i)
  {
    pDest[i]=pSrc[lpData->nLength++];
  }    
  *pcb=i*sizeof(WORD);

  return 0;
}

void DoEditPaste(HWND hWndEdit)
{    
  EDITSTREAM es;
  GLOBALDATA gd;
  HGLOBAL hData;
  LPVOID pData;

  if (!OpenClipboard(hWndEdit))
    return;

  if ((hData=GetClipboardData(CF_UNICODETEXT)) && (pData=GlobalLock(hData)))
  {
    gd.pData=(unsigned char *)pData;
    gd.nLength=0;
    es.dwCookie=(DWORD)&gd;
    es.pfnCallback=PasteCallback;
    SendMessage(hWndEdit, EM_STREAMIN, SF_TEXT|SF_UNICODE|SFF_SELECTION, (LPARAM)&es);
    GlobalUnlock(hData);
  }
  else if ((hData=GetClipboardData(CF_TEXT)) && (pData=GlobalLock(hData)))
  {
    SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)pData);
    GlobalUnlock(hData);
  }
  CloseClipboard();
}

void DoEditClear(HWND hWndEdit)
{
  SendMessage(hWndEdit,EM_REPLACESEL,TRUE,(LPARAM)"");
}

void DoEditSelectAll(HWND hWndEdit)
{
  CHARRANGE selrng;

  selrng.cpMin=0;
  selrng.cpMax=-1;
  SendMessage(hWndEdit,EM_EXSETSEL,0,(LPARAM)&selrng);
}

void DoEditInsertChar(HWND hWndEdit)
{
  ShellExecute(hMainWnd,"open","charmap.exe",NULL,NULL,SW_SHOWDEFAULT);
}

BOOL DoEditInsertCharInSelection(HWND hWndEdit, int nAction, char ch)
{
  char *pText;
  TEXTRANGE txtrng;
  int layout;
  int a, b, c;
  int textsize;
  int tabs_number;
  int minline;
  int maxline;
  int minlineindex;
  int maxlineindex;
  int maxlinelength;
  BOOL cr_less_end=FALSE;

  if (chrg.cpMin != chrg.cpMax)
  {
    txtrng.chrg.cpMin=chrg.cpMin;
    txtrng.chrg.cpMax=chrg.cpMax;
    minline=SendMessage(hWndEdit,EM_LINEFROMCHAR,txtrng.chrg.cpMin,0);
    maxline=SendMessage(hWndEdit,EM_LINEFROMCHAR,txtrng.chrg.cpMax,0);
    minlineindex=SendMessage(hWndEdit,EM_LINEINDEX,minline,0);
    maxlineindex=SendMessage(hWndEdit,EM_LINEINDEX,maxline,0);
    maxlinelength=SendMessage(hWndEdit,EM_LINELENGTH,txtrng.chrg.cpMax,0);

    if (minline != maxline || (minlineindex == txtrng.chrg.cpMin && !maxlinelength))
    {
      if (nAction == CHECK_STATE) return TRUE;
      if (maxlineindex != txtrng.chrg.cpMax)
      {
        if (maxlinelength) txtrng.chrg.cpMax=maxlineindex + maxlinelength + 1;
        else cr_less_end=TRUE;
      }
      else --maxline;

      txtrng.chrg.cpMin=minlineindex;
      SendMessage(hWndEdit,EM_EXSETSEL,0,(LPARAM)&txtrng.chrg);

      if (nAction == CHAR_INSERT)
      {
        tabs_number=maxline - minline + 1;
        textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin + 1;

        if (pText=(char *)HeapAlloc(GetProcessHeap(),0,textsize + tabs_number + 1))
        {
          layout=SetLayout();
          txtrng.lpstrText=pText + tabs_number;
          SendMessage(hWndEdit,EM_GETTEXTRANGE,0,(LPARAM)&txtrng);
          RestoreLayout(layout);

          for (a=1, b=tabs_number, c=1, pText[0]=ch; c < tabs_number; pText[a++]=pText[b++])
            while (pText[b] == '\r' && c < tabs_number)
            {
              pText[a++]=pText[b++];
              pText[a++]=ch;
              ++c;
            }
        }
        else
        {
          API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY, buf, TEMP_BUFFER_SIZE);
          MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
          return FALSE;
        }
      }
      else if (nAction == CHAR_DELETE)
      {
        textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin + 1;

        if (pText=(char *)HeapAlloc(GetProcessHeap(),0,textsize + 2))
        {
          layout=SetLayout();
          txtrng.lpstrText=pText + 1;
          SendMessage(hWndEdit,EM_GETTEXTRANGE,0,(LPARAM)&txtrng);
          RestoreLayout(layout);

          for (a=0, b=(pText[1] == ch)?2:1; b <= textsize; pText[a++]=pText[b++])
            while (pText[b] == '\r')
            {
              pText[a++]=pText[b++];
              if (pText[b] == ch) ++b;
            }
        }
        else
        {
          API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY, buf, TEMP_BUFFER_SIZE);
          MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
          return FALSE;
        }
      }
      SendMessage(hWndEdit,EM_REPLACESEL,TRUE,(LPARAM)pText);
      if (cr_less_end) txtrng.chrg.cpMax=chrg.cpMax + 1;
      else txtrng.chrg.cpMax=chrg.cpMax;
      SendMessage(hWndEdit,EM_EXSETSEL,0,(LPARAM)&txtrng.chrg);
      HeapFree(GetProcessHeap(),0,(LPVOID)pText);
      return TRUE;
    }
  }
  if (nAction == CHECK_STATE) return FALSE;
  buf[0]=ch;
  buf[1]='\0';
  SendMessage(hWndEdit,EM_REPLACESEL,TRUE,(LPARAM)buf);
  return TRUE;
}

BOOL DoEditDeleteTrailingWhitespaces(HWND hWndEdit, int nAction)
{
  char *pText;
  TEXTRANGE txtrng;
  int layout;
  int a, b;
  int textsize;
  int maxline;
  int maxlineindex;
  int maxlinelength;
  BOOL cr_less_end=FALSE;

  if (chrg.cpMin != chrg.cpMax)
  {
    if (nAction == CHECK_TRAILING_WHITESPACES) return TRUE;
    txtrng.chrg.cpMin=chrg.cpMin;
    txtrng.chrg.cpMax=chrg.cpMax;
    maxline=SendMessage(hWndEdit,EM_LINEFROMCHAR,txtrng.chrg.cpMax,0);
    maxlineindex=SendMessage(hWndEdit,EM_LINEINDEX,maxline,0);
    maxlinelength=SendMessage(hWndEdit,EM_LINELENGTH,txtrng.chrg.cpMax,0);

    if (nAction == DELETE_TRAILING_WHITESPACES)
    {
      if (maxlineindex != txtrng.chrg.cpMax && !maxlinelength)
        cr_less_end=TRUE;
      textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin + 1;

      if (pText=(char *)HeapAlloc(GetProcessHeap(),0,textsize + 2))
      {
        layout=SetLayout();
        txtrng.lpstrText=pText + 1;
        SendMessage(hWndEdit,EM_GETTEXTRANGE,0,(LPARAM)&txtrng);
        RestoreLayout(layout);

        for (a=0, b=1; b <= textsize; pText[a++]=pText[b++])
          while (pText[b] == '\r' || pText[b] == '\0')
          {
            do --a;
            while (a >= 0 && (pText[a] == '\t' || pText[a] == ' '));

            ++a;
            pText[a++]=pText[b++];
          }
      }
      else
      {
        API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY, buf, TEMP_BUFFER_SIZE);
        MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
        return FALSE;
      }

      SendMessage(hWndEdit,EM_REPLACESEL,TRUE,(LPARAM)pText);
      if (cr_less_end) txtrng.chrg.cpMax=chrg.cpMax + 1;
      else txtrng.chrg.cpMax=chrg.cpMax;
      SendMessage(hWndEdit,EM_EXSETSEL,0,(LPARAM)&txtrng.chrg);
      HeapFree(GetProcessHeap(),0,(LPVOID)pText);
      return TRUE;
    }
  }
  if (nAction == CHECK_TRAILING_WHITESPACES) return FALSE;
  SendMessage(hWndEdit,WM_KEYDOWN,VK_BACK,0);
  return TRUE;
}

void DoEditChangeCase(HWND hWndEdit, int nCase)
{
  TEXTRANGE txtrng;
  int textsize;
  char *pStart;
  char *pEnd;
  int layout;

  if (chrg.cpMin != chrg.cpMax)
  {
    txtrng.chrg.cpMin=chrg.cpMin;
    txtrng.chrg.cpMax=chrg.cpMax;
    textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin;

    pStart=txtrng.lpstrText=(char *)HeapAlloc(GetProcessHeap(),0,textsize + 1);
    if (!txtrng.lpstrText)
    {
      API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY, buf, TEMP_BUFFER_SIZE);
      MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
      return;
    }
    layout=SetLayout();

    pEnd=pStart + textsize;
    SendMessage(hWndEdit,EM_GETTEXTRANGE,0,(LPARAM)&txtrng);

    switch(nCase)
    {
      case UPPERCASE:
        CharUpperBuff(txtrng.lpstrText,textsize);
        break;

      case LOWERCASE:
        CharLowerBuff(txtrng.lpstrText,textsize);
        break;

      case SENTENCECASE:
        while (pStart < pEnd)
        {
          while (pStart < pEnd && (*pStart == ' ' || *pStart == '\t' || strchr(szSentenceSelimiters, *pStart)))
            ++pStart;

          if (pStart < pEnd) *pStart++=(char)CharUpper((char*)(unsigned)(unsigned char)*pStart);

          while (pStart < pEnd && !strchr(szSentenceSelimiters, *pStart))
            *pStart++=(char)CharLower((char*)(unsigned)(unsigned char)*pStart);
        }
        break;

      case TITLECASE:
        while (pStart < pEnd)
        {
          while (pStart < pEnd && strchr(szTitleDelimiters, *pStart))
            ++pStart;

          if (pStart < pEnd) *pStart++=(char)CharUpper((char*)(unsigned)(unsigned char)*pStart);

          while (pStart < pEnd && !strchr(szTitleDelimiters, *pStart))
            *pStart++=(char)CharLower((char*)(unsigned)(unsigned char)*pStart);
        }
        break;

      case INVERTCASE:
        while (pStart < pEnd)
        {
          if (IsCharLower(*pStart))
            *pStart++=(char)CharUpper((char*)(unsigned)(unsigned char)*pStart);
          else
            *pStart++=(char)CharLower((char*)(unsigned)(unsigned char)*pStart);
        }
        break;
    }
    SendMessage(hWndEdit,EM_REPLACESEL,TRUE,(LPARAM)txtrng.lpstrText);
    SendMessage(hWndEdit,EM_EXSETSEL,0,(LPARAM)&txtrng.chrg);
    HeapFree(GetProcessHeap(),0,(LPVOID)txtrng.lpstrText);
    RestoreLayout(layout);
  }
}

void DoEditWrap(HWND hWndEdit)
{
  NMHDR nmhdr;

  if (bWrapOn=!bWrapOn)
  {
    SendMessage(hWndEdit,EM_SETTARGETDEVICE,(WPARAM)NULL,0);
    CheckMenuItem(hMenu,IDM_EDIT_WRAP,MF_CHECKED);
  }
  else
  {
    SendMessage(hWndEdit,EM_SETTARGETDEVICE,(WPARAM)NULL,1);
    CheckMenuItem(hMenu,IDM_EDIT_WRAP,MF_UNCHECKED);
  }

  nmhdr.hwndFrom=hWndEdit;
  nmhdr.idFrom=ID_EDIT;
  nmhdr.code=EN_SELCHANGE;

  SendMessage(hMainWnd,WM_NOTIFY,ID_EDIT,(LPARAM)&nmhdr);
}

void DoEditKeepSpace(HWND hWndEdit)
{
  if (bKeepOn=!bKeepOn)
    CheckMenuItem(hMenu,IDM_EDIT_KEEPSPACE,MF_CHECKED);
  else
    CheckMenuItem(hMenu,IDM_EDIT_KEEPSPACE,MF_UNCHECKED);
}

void DoSearchFind(HWND hWndEdit)
{
  if (hDlgModeless == NULL)
  {
    bReplaceDlg=FALSE;
    if (ftflags&FR_SELECTION) ftflags&=~FR_SELECTION;

    if (hDlgModeless=CreateDialogParam(hLangLib,MAKEINTRESOURCE(IDD_FIND),hMainWnd,(DLGPROC)FindAndReplaceDlgProc,(LPARAM)hWndEdit))
    {
      ShowWindow(hDlgModeless,SW_SHOW);
    }
  }
}

void DoSearchFindNextDown(HWND hWndEdit)
{
  DWORD tmpflags=ftflags; 

  if (org_query)
  {
    ftflags&=~FR_UP&~FR_BEGINNING&~FR_SELECTION;
    ftflags|=FR_DOWN;
    FindText(hWndEdit);
    ftflags=tmpflags;
  }
  else DoSearchFind(hWndEdit);
}

void DoSearchFindNextUp(HWND hWndEdit)
{
  DWORD tmpflags=ftflags; 

  if (org_query)
  {
    ftflags&=~FR_DOWN&~FR_BEGINNING&~FR_SELECTION;
    ftflags|=FR_UP;
    FindText(hWndEdit);
    ftflags=tmpflags;
  }
  else DoSearchFind(hWndEdit);
}

void DoSearchReplace(HWND hWndEdit)
{
  if (hDlgModeless == NULL)
  {
    bReplaceDlg=TRUE;

    if (hDlgModeless=CreateDialogParam(hLangLib,MAKEINTRESOURCE(IDD_REPLACE),hMainWnd,(DLGPROC)FindAndReplaceDlgProc,(LPARAM)hWndEdit))
    {
      ShowWindow(hDlgModeless,SW_SHOW);
    }
  }
}

void DoSearchGoToLine(HWND hWndEdit)
{
  if (hDlgModeless == NULL)
  {
    if (hDlgModeless=CreateDialogParam(hLangLib,MAKEINTRESOURCE(IDD_GOTOLINE),hMainWnd,(DLGPROC)GoToLineDlgProc,(LPARAM)hWndEdit))
    {
      ShowWindow(hDlgModeless,SW_SHOW);
    }
  }
}

int DoSelectCodePage(HWND hWndEdit)
{
  nDialogCP=-1;
  DialogBox(hLangLib,MAKEINTRESOURCE(IDD_SELECTCODEPAGE),hWndEdit,(DLGPROC)SelectDlgProc);
  return nDialogCP;
}

void DoSettingsFont(HWND hWndEdit)
{
  cf.lStructSize   =sizeof(CHOOSEFONT);
  cf.hwndOwner     =hMainWnd;
  cf.hDC           =NULL;
  cf.lpLogFont     =&logfont;
  cf.iPointSize    =0;
  cf.Flags         =CF_INITTOLOGFONTSTRUCT|CF_SCREENFONTS|CF_EFFECTS|CF_FORCEFONTEXIST;
  cf.lCustData     =0;
  cf.lpfnHook      =NULL;
  cf.lpTemplateName=NULL;
  cf.hInstance     =NULL;
  cf.lpszStyle     =NULL;
  cf.nFontType     =0;
  cf.nSizeMin      =0;
  cf.nSizeMax      =0;

  memcpy(&logfont2,&logfont,sizeof(LOGFONT));
  if (ChooseFont(&cf))
  {
    SetChosenFont(hWndEdit);
  }
  else
  {
    memcpy(&logfont,&logfont2,sizeof(LOGFONT));
  }
}

void DoSettingsBG(HWND hWndEdit)
{
  COLORREF temp=cc.rgbResult;

  if (ChooseColor(&cc))
  {
    SendMessage(hWndEdit,EM_SETBKGNDCOLOR,0,cc.rgbResult);
    bUseSystemBckgColor=FALSE;
  }
  else cc.rgbResult=temp;
}

void DoSettingsSaveTime(HWND hWndEdit)
{
  if (bSaveTime=!bSaveTime)
    CheckMenuItem(hMenu,IDM_SETTINGS_SAVETIME,MF_CHECKED);
  else
    CheckMenuItem(hMenu,IDM_SETTINGS_SAVETIME,MF_UNCHECKED);
}

void DoSettingsNoMultiOpen(HWND hWndEdit)
{
  if (bOpenInNewWindow=!bOpenInNewWindow)
    CheckMenuItem(hMenu,IDM_SETTINGS_NOMULTIOPEN,MF_UNCHECKED);
  else
    CheckMenuItem(hMenu,IDM_SETTINGS_NOMULTIOPEN,MF_CHECKED);
}

void DoSettingsOnTop(HWND hWndEdit)
{
  if (bOnTop=!bOnTop)
  {
    SetWindowPos(hMainWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
    CheckMenuItem(hMenu,IDM_SETTINGS_ONTOP,MF_CHECKED);
  }
  else
  {
    SetWindowPos(hMainWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
    CheckMenuItem(hMenu,IDM_SETTINGS_ONTOP,MF_UNCHECKED);
  }
}

BOOL DoCodePageOpenAs(HWND hWndEdit, int nCP)
{
  int nChoice;
  int tmp=nCurrentCodePage;

  if (nCP == -1) return FALSE;

  if (*ofn.lpstrFile)
  {
    if (!GetModify())
    {
      nCurrentCodePage=nCP;
      OpenDocument(hWndEdit);
      DisplayCodePage(nCurrentCodePage);
      return TRUE;
    }
    else
    {
      API_LoadString(hLangLib, MSG_FILE_WILL_BE_REOPENED, buf, TEMP_BUFFER_SIZE);
      if (MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_OKCANCEL|MB_ICONEXCLAMATION) == IDOK)
      {
        nCurrentCodePage=nCP;
        OpenDocument(hWndEdit);
        DisplayCodePage(nCurrentCodePage);
        return TRUE;
      }
    }
  }
  else
  {
    ofn.Flags=OFN_CREATEPROMPT|OFN_LONGNAMES|OFN_HIDEREADONLY;
    ofn.lpstrDefExt=NULL;

    if (GetModify())
    {
      API_LoadString(hLangLib, MSG_DOCUMENT_CHANGED, buf, TEMP_BUFFER_SIZE);
      nChoice=MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_YESNOCANCEL|MB_ICONEXCLAMATION);

      if (nChoice == IDYES)
      {
        nCurrentCodePage=nCP;
        if (!DoFileSave(hWndEdit))
        {
          nCurrentCodePage=tmp;
          return FALSE;
        }
        DisplayCodePage(nCurrentCodePage);
        return TRUE;
      }
      else if (nChoice == IDCANCEL) return FALSE;
    }

    if (GetOpenFileName(&ofn))
    {
      nCurrentCodePage=nCP;
      OpenDocument(hWndEdit);
      DisplayCodePage(nCurrentCodePage);
      return TRUE;
    }
  }
  return FALSE;
}

BOOL DoCodePageSaveIn(HWND hWndEdit, int nCP)
{
  int tmp=nCurrentCodePage;

  if (nCP == -1) return FALSE;

  if (!*ofn.lpstrFile)
  {
    nCurrentCodePage=nCP;
    if (!DoFileSaveAs(hWndEdit))
    {
      nCurrentCodePage=tmp;
      return FALSE;
    }
    DisplayCodePage(nCurrentCodePage);
    return TRUE;
  }
  nCurrentCodePage=nCP;
  SaveDocument(hWndEdit);
  DisplayCodePage(nCurrentCodePage);
  return TRUE;
}

void DoHelpAbout(HWND hWndEdit)
{
  DialogBox(hLangLib,MAKEINTRESOURCE(IDD_ABOUT),hMainWnd,(DLGPROC)AboutDlgProc);
}

void DoNonMenuDelLine(HWND hWndEdit)
{
  int line;
  CHARRANGE selrng;

  line=SendMessage(hWndEdit,EM_LINEFROMCHAR,nPosition,0);
  selrng.cpMin=SendMessage(hWndEdit,EM_LINEINDEX,line,0);
  selrng.cpMax=selrng.cpMin + SendMessage(hWndEdit,EM_LINELENGTH,nPosition,0) + 1;

  SendMessage(hWndEdit,EM_EXSETSEL,0,(LPARAM)&selrng);
  SendMessage(hWndEdit,EM_REPLACESEL,TRUE,(LPARAM)"");
}

DWORD CALLBACK InputStreamCallback(DWORD dwCookie,LPBYTE pbBuff,LONG cb,LONG FAR *pcb)
{
 /*
  * Some unmaintainable code in this function
  */
  int iBytesToRestore,iBytesWritten=0,iBytesRead,iTemp;
  unsigned char *endptr;
  static int iAddReadBytes,iTranslateBufferSize;
  wchar_t *win_ptr,*unix_ptr;

  if (firsttime)
  {
    iAddReadBytes=0;
    iTranslateBufferSize=0;
  }

  if (iTranslateBufferSize)
  {
    iBytesToRestore=(cb<iTranslateBufferSize)?cb:iTranslateBufferSize;
    iTranslateBufferSize-=iBytesToRestore;
    iBytesWritten+=iBytesToRestore;
    memcpy(pbBuff,pcTranslateBuffer,iBytesToRestore);
    if (iTranslateBufferSize) memmove(pcTranslateBuffer,pcTranslateBuffer+iBytesToRestore,iTranslateBufferSize);
  }

  while (iBytesWritten<cb)
  {
    if (!ReadFile((HANDLE)dwCookie,pcReadBuffer+iAddReadBytes,READBUFFERSIZE-iAddReadBytes,(DWORD *)&iBytesRead,NULL))
    {
      API_LoadString(hLangLib, MSG_ERROR_IO, buf, TEMP_BUFFER_SIZE);
      MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
      return 0xFFFFFFFF;
    }

    if (firsttime)
    {
      if (iBytesRead<3)
      {
        if (!ReadFile((HANDLE)dwCookie,pcReadBuffer+iAddReadBytes+iBytesRead,1,(DWORD *)&iTemp,NULL))
        {
          API_LoadString(hLangLib, MSG_ERROR_IO, buf, TEMP_BUFFER_SIZE);
          MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
          return 0xFFFFFFFF;
        }
        if (iTemp) iBytesRead++;
        if (!ReadFile((HANDLE)dwCookie,pcReadBuffer+iAddReadBytes+iBytesRead+iTemp,1,(DWORD *)&iTemp,NULL))
        {
          API_LoadString(hLangLib, MSG_ERROR_IO, buf, TEMP_BUFFER_SIZE);
          MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
          return 0xFFFFFFFF;
        }
        if (iTemp) iBytesRead++;
      }
    }

    if (iBytesRead == 0) break;

    iTranslateBufferSize=TranslateTextToRepresent(pcReadBuffer,iBytesRead+iAddReadBytes,pcTranslateBuffer,&endptr,firsttime);
    if (firsttime) firsttime=FALSE;
    if (!iTranslateBufferSize && endptr == pcTranslateBuffer)
    {
      API_LoadString(hLangLib, MSG_ERROR_CANNOT_TRANSLATE, buf, TEMP_BUFFER_SIZE);
      MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
      return 0xFFFFFFFF;
    }

    if (!bNewLineDetected)
    {
      win_ptr=wmemchr((wchar_t*)pcTranslateBuffer,0x0D,iTranslateBufferSize/2);
      unix_ptr=wmemchr((wchar_t*)pcTranslateBuffer,0x0A,iTranslateBufferSize/2);
      if (win_ptr && !unix_ptr)
      {
        bNewLineDetected=TRUE;
      }
      else if (!win_ptr && unix_ptr)
      {
        bNewLineDetected=TRUE;
        bUnixNewLine=TRUE;
      }
      else if (win_ptr && unix_ptr)
      {
        if (unix_ptr<win_ptr) bUnixNewLine=TRUE;
        bNewLineDetected=TRUE;
      }
    }

    iBytesToRestore=((cb-iBytesWritten)<iTranslateBufferSize)?(cb-iBytesWritten):iTranslateBufferSize;
    if (iBytesToRestore) memcpy(pbBuff+iBytesWritten,pcTranslateBuffer,iBytesToRestore);
    iTranslateBufferSize-=iBytesToRestore;
    iBytesWritten+=iBytesToRestore;
    iAddReadBytes=iBytesRead+iAddReadBytes-(endptr-pcReadBuffer);
    if (iTranslateBufferSize) memmove(pcTranslateBuffer,pcTranslateBuffer+iBytesToRestore,iTranslateBufferSize);
    if (iAddReadBytes)
    {
      memmove(pcReadBuffer,endptr,iBytesRead-iAddReadBytes);
    }
  }

  *pcb=iBytesWritten;

  return 0;
}

int TranslateNewlinesToUnix(wchar_t *buffer,int iBufSize)
{
  int rindex,windex;

  rindex=0;windex=0;

  while (rindex <= (iBufSize/2)-1)
  {
    buffer[windex]=buffer[rindex];
    if (buffer[rindex] != 0x0D)
    {
      windex++;
    }
    rindex++;
  }

  return windex*2;
}

DWORD CALLBACK OutputStreamCallback(DWORD dwCookie,LPBYTE pbBuff,LONG cb,LONG FAR *pcb)
{
 /*
  * Some unmaintainable code in this function
  */
  char *pcReadingFrom;
  int iFormBuffer=0;
  int iBytesTranslated,iBytesWritten;
  DWORD iBytesWrittenNow;
  int iTemp;
  int iRealBytes;

  if (bUnixNewLine) iRealBytes=TranslateNewlinesToUnix((wchar_t *)pbBuff,cb);
  else iRealBytes=cb;

  pcReadingFrom=(char *)pbBuff;

  do
  {
    iBytesWritten=0;
    while (iFormBuffer<READBUFFERSIZE && (pcReadingFrom-(char *)pbBuff)<iRealBytes)
    {
      iTemp=iRealBytes-(pcReadingFrom-(char *)pbBuff);
      if (READBUFFERSIZE-iFormBuffer<iTemp) iTemp=READBUFFERSIZE-iFormBuffer;
      memcpy(&pcReadBuffer[iFormBuffer],pcReadingFrom,iTemp);
      iFormBuffer+=iTemp;
      pcReadingFrom+=iTemp;
    }

    iBytesTranslated=TranslateTextFromRepresent(pcReadBuffer,iFormBuffer,pcTranslateBuffer,firsttime);
    if (!iBytesTranslated)
    {
      API_LoadString(hLangLib, MSG_ERROR_CANNOT_TRANSLATE, buf, TEMP_BUFFER_SIZE);
      MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
      return 0xFFFFFFFF;
    }
    if (firsttime) firsttime=false;

    do
    {
      if (!WriteFile((HANDLE)dwCookie,pcTranslateBuffer+iBytesWritten,iBytesTranslated-iBytesWritten,&iBytesWrittenNow,NULL))
      {
        API_LoadString(hLangLib, MSG_ERROR_IO, buf, TEMP_BUFFER_SIZE);
        MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
        return 0xFFFFFFFF;
      }
      iBytesWritten+=iBytesWrittenNow;
    }
    while (iBytesWritten<iBytesTranslated);

    iFormBuffer=0;
  }
  while ((pcReadingFrom-(char *)pbBuff)<iRealBytes && !((pcReadingFrom-(char *)pbBuff)%2));

  *pcb=cb;

  return 0;
}

DWORD CALLBACK DummyOutputStreamCallback(DWORD dwCookie,LPBYTE pbBuff,LONG cb,LONG FAR *pcb)
{
  if (!WriteFile((HANDLE)dwCookie,pbBuff,(DWORD) cb,(DWORD *)pcb,NULL))
  {
    API_LoadString(hLangLib, MSG_ERROR_IO, buf, TEMP_BUFFER_SIZE);
    MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
    return 0xFFFFFFFF;
  }
  return 0;
}

DWORD CALLBACK DummyInputStreamCallback(DWORD dwCookie,LPBYTE pbBuff,LONG cb,LONG FAR *pcb)
{
  char *win_ptr, *unix_ptr;

  if (!ReadFile((HANDLE)dwCookie,pbBuff,(DWORD) cb,(DWORD *)pcb,NULL))
  {
    API_LoadString(hLangLib, MSG_ERROR_IO, buf, TEMP_BUFFER_SIZE);
    MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
    return 0xFFFFFFFF;
  }
  if (!bNewLineDetected)
  {
    win_ptr=(char *)memchr(pbBuff,0x0D,*pcb);
    unix_ptr=(char *)memchr(pbBuff,0x0A,*pcb);
    if (win_ptr && !unix_ptr)
    {
      bNewLineDetected=TRUE;
    }
    else if (!win_ptr && unix_ptr)
    {
      bNewLineDetected=TRUE;
      bUnixNewLine=TRUE;
    }
    else if (win_ptr && unix_ptr)
    {
      if (unix_ptr<win_ptr) bUnixNewLine=TRUE;
      bNewLineDetected=TRUE;
    }
  }
  return 0;
}

int TranslateTextToRepresent(LPBYTE pcBuff, int iBufSize, LPBYTE pcOutBuf, LPBYTE *endptr, BOOL firsttime)
{
  int iBytesInOut=0;
  int i;
  unsigned char ch;
  unsigned char *p;

  if (firsttime)
  {
    bAppendHeader=FALSE;
    //remember that we shall have at least 3 bytes at first time ;-)
    if (nCurrentCodePage == CP_UNICODE_UCS2_LE)
    {
      if (iBufSize >= 2)
      {
        if (!memcmp(pcBuff,"\xFF\xFE",2)) bAppendHeader=TRUE;
      }
    }
    else if (nCurrentCodePage == CP_UNICODE_UTF8)
    {
      if (iBufSize >= 3)
      {
        if (!memcmp(pcBuff,"\xEF\xBB\xBF",3)) bAppendHeader=TRUE;
      }
    }
    else bAppendHeader=TRUE;
  }

  *endptr=&pcBuff[iBufSize];

  if (nCurrentCodePage == CP_UNICODE_UCS2_BE)
  {
    if (iBufSize%2)
    {
      iBufSize--;
      endptr--;
    }
    ChangeByteOrder(pcBuff,iBufSize);
  }

  if (nCurrentCodePage == CP_UNICODE_UCS2_LE || nCurrentCodePage == CP_UNICODE_UCS2_BE)
  {
    if (!firsttime || iBufSize<2 || memcmp(pcBuff,"\xFF\xFE",2))
    {
      memcpy(pcOutBuf,pcBuff,iBufSize);
      iBytesInOut=iBufSize;
    }
    else
    {
      memcpy(pcOutBuf,&pcBuff[2],iBufSize-2);
      iBytesInOut=iBufSize-2;
    }
  }
  else if (nCurrentCodePage == CP_UNICODE_UTF8)
  {
    //Parse UTF-8 sequence
    //Support only chars up to three bytes (UCS-4 - go away!)
    //Warning: Partial decoding is possible!
    i=0;
    if (firsttime && iBufSize >= 3 && !memcmp(pcBuff,"\xEF\xBB\xBF",3)) i+=3;
    while (i <= iBufSize-1)
    {
      ch=pcBuff[i];
      if (!(ch&0x80))
      {
        pcOutBuf[iBytesInOut++]=ch;
        pcOutBuf[iBytesInOut++]='\0';
      }
      else if (!(ch&0x20))
      {
        pcOutBuf[iBytesInOut++]=(ch>>2)&0x07;
        i++;
        if (i >= iBufSize)
        {
          *endptr=&pcBuff[iBufSize-1];
          iBytesInOut--;
          break;
        }
        pcOutBuf[iBytesInOut++]=(pcBuff[i]&0x3F)|(ch<<6);
        swap(pcOutBuf[iBytesInOut-1],pcOutBuf[iBytesInOut-2]);
      }
      else if (!(ch&0x10))
      {
        i++;
        if (i >= iBufSize)
        {
          *endptr=&pcBuff[iBufSize-1];
//        iBytesInOut--;
          break;
        }
        pcOutBuf[iBytesInOut++]=(ch<<4)|((pcBuff[i]>>2)&0x0F);
        ch=pcBuff[i];
        i++;
        if (i >= iBufSize)
        {
          *endptr=&pcBuff[iBufSize-2];
//        iBytesInOut-=2;
          iBytesInOut--;
          break;
        }
        pcOutBuf[iBytesInOut++]=(pcBuff[i]&0x3F)|(ch<<6);
        swap(pcOutBuf[iBytesInOut-1],pcOutBuf[iBytesInOut-2]);
      }
      else
      {
        p=&pcBuff[i];
        pcOutBuf[iBytesInOut++]='\x3F';
        pcOutBuf[iBytesInOut++]='\0';
        if (!(ch&0x08)) i+=3;
        else if (!(ch&0x04)) i+=4;
        else if (!(ch&0x02)) i+=5;
        if (i>iBufSize)
        {
          *endptr=p;
          iBytesInOut-=2;
          break;
        }
      }
      i++;
    }
  }
  else
  {
    //Decoding is always full and unambigiouis
    iBytesInOut=2*MultiByteToWideChar(nCurrentCodePage,MB_PRECOMPOSED,(char *)pcBuff,iBufSize,(wchar_t *)pcOutBuf,TRANSLATEBUFFERSIZE/2);
    if (!iBytesInOut) return 0;
  }
  
  return iBytesInOut;
}

int TranslateTextFromRepresent(LPBYTE pcBuff, int iBufSize, LPBYTE pcOutBuf, BOOL firsttime)
{
  //This function requires even number of bytes in input buffer
  //It provides always full encoding

  int iBytesInOut,i;
  unsigned char *pOut;

  if (nCurrentCodePage == CP_UNICODE_UCS2_LE || nCurrentCodePage == CP_UNICODE_UCS2_BE)
  {
    if (!firsttime || !bAppendHeader)
    {
      memcpy(pcOutBuf,pcBuff,iBufSize);
      if (nCurrentCodePage == CP_UNICODE_UCS2_BE) ChangeByteOrder(pcOutBuf,iBufSize);
      return iBufSize;
    }
    else
    {
      memcpy(pcOutBuf,"\xFF\xFE",2);
      memcpy(pcOutBuf+2, pcBuff,iBufSize);
      if (nCurrentCodePage == CP_UNICODE_UCS2_BE) ChangeByteOrder(pcOutBuf,iBufSize+2);
      return iBufSize+2;
    }
  }
  else if (nCurrentCodePage == CP_UNICODE_UTF8)
  {
    pOut=pcOutBuf;
  
    if (firsttime && bAppendHeader)
    {
      *pOut='\xEF';
      pOut++;
      *pOut='\xBB';
      pOut++;
      *pOut='\xBF';
      pOut++;
    }
  
    for (i=0;i <= (iBufSize/2)-1;i++)
    {
      if (*(WORD*)&pcBuff[2*i] <= 0x7F)
      {
        *pOut=pcBuff[2*i];
        pOut++;
      }
      else if (*(WORD*)&pcBuff[2*i] <= 0x7FF)
      {
        *pOut=HIBYTE(((*(WORD*)&pcBuff[2*i])<<2))|0xC0;
        pOut++;
        *pOut=(pcBuff[2*i]&0x3F)|0x80;
        pOut++;
      }
      else
      {
        *pOut=(pcBuff[2*i+1]>>4)|0xE0;
        pOut++;
        *pOut=HIBYTE(((*(WORD*)&pcBuff[2*i])<<2))&0x3F|0x80;
        pOut++;
        *pOut=(pcBuff[2*i])&0x3F|0x80;
        pOut++;
      }
    }
    return pOut-pcOutBuf;
  }
  else
  {
    iBytesInOut=WideCharToMultiByte(nCurrentCodePage,WC_COMPOSITECHECK|WC_DISCARDNS,(wchar_t *)pcBuff,iBufSize/2,(char *)pcOutBuf,TRANSLATEBUFFERSIZE,NULL,NULL);
    if (!iBytesInOut) return 0;
    return iBytesInOut;
  }
}

void swap(unsigned char &c1, unsigned char &c2)
{
  unsigned char ch;
  ch=c1;
  c1=c2;
  c2=ch;
}

void ChangeByteOrder(unsigned char *buf, unsigned int len)
{
  unsigned char chByte;
  unsigned int a;
  unsigned int b;
  
  for (a=0, b=1; a < len; a+=2, b+=2)
  {
    chByte=buf[a];
    buf[a]=buf[b];
    buf[b]=chByte;
  }
}

void AutodetectCodePage(unsigned char *pcBuffer, int iCount)
{
/*
  int counter[128];
  int i,exchars=0;
  unsigned char ch;
  char szOEMwatermark[]="\xAE\xA5\xA0\xA8\xBA\xCD\xB3\xC4\xB0\xB1\xB2\xDB";
  char szANSIwatermark[]="\xEE\xE5\xE0\xE8\xED\xF2\xCE\xC5\xC0\xC8\xD2\x97";
  char szKOIwatermark[]="\xCF\xC5\xC1\xC9\xCE\xD4\xEF\xE5\x80";
  char szUTF8watermark[]="\xD0\xD1";
  int iOEMrate=0,iANSIrate=0,iKOIrate=0,iUTF8rate=0;
//  double iOEMrate=0,iANSIrate=0,iKOIrate=0,iUTF8rate=0;
*/

  //check if file is Unicode
  if (!memcmp(pcBuffer,"\xFF\xFE",2))
  {
    DisplayCodePage(CP_UNICODE_UCS2_LE);
    nCurrentCodePage=CP_UNICODE_UCS2_LE;
  }
  else if (!memcmp(pcBuffer,"\xFE\xFF",2))
  {
    DisplayCodePage(CP_UNICODE_UCS2_BE);
    nCurrentCodePage=CP_UNICODE_UCS2_BE;
  }
  else if (!memcmp(pcBuffer,"\xEF\xBB\xBF",3))
  {
    DisplayCodePage(CP_UNICODE_UTF8);
    nCurrentCodePage=CP_UNICODE_UTF8;
  }
  return;

/*
  //Count number of each character in input buffer
  ZeroMemory(counter,128*sizeof(int));
  for (i=0;i <= iCount-1;i++)
  {
    if (pcBuffer[i] >= 0x80)
    {
      exchars++;
      counter[pcBuffer[i]-0x80]++;
    }
  }

  //Give it up if there's no representative selection
  if (exchars<15)
  {
    DisplayCodePage(CP_ACP);
    return TRUE;
  }

  for (i=0;i <= 9;i++)
  {
    ch=getmaxelement(counter,128);
    if (!counter[ch]) break;

    if (strchr(szOEMwatermark,ch+0x80)) iOEMrate+=counter[ch];
    if (strchr(szANSIwatermark,ch+0x80)) iANSIrate+=counter[ch];
    if (strchr(szKOIwatermark,ch+0x80)) iKOIrate+=counter[ch];
    if (strchr(szUTF8watermark,ch+0x80)) iUTF8rate+=counter[ch];
    counter[ch]=0;
  }

  iANSIrate*=12; //because ANSI is the most popular in Win32
//  iANSIrate*=1.2; //because ANSI is the most popular in Win32

  if (iANSIrate >= iOEMrate && iANSIrate >= iKOIrate && iANSIrate >= iUTF8rate)
  {
    DisplayCodePage(CP_ACP);
    return TRUE;
  }
  if (iOEMrate >= iKOIrate && iOEMrate >= iUTF8rate)
  {
    DisplayCodePage(nOemCodePage);
    return TRUE;
  }
  if (iKOIrate >= iUTF8rate)
  {
    DisplayCodePage(KOI8_R);
    return TRUE;
  }
  DisplayCodePage(CP_UNICODE_UTF8);
  return TRUE;
*/
}

int getmaxelement(int *base,int iCount)
{
  int maxvalue,number,i;

  if (iCount == 0) return 0;
  maxvalue=base[0];
  number=0;
  for (i=1;i <= iCount-1;i++)
  {
    if (base[i]>maxvalue)
    {
      maxvalue=base[i];
      number=i;
    }
  }
  return number;
}

BOOL CALLBACK SelectDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  WCHAR wc;
  char c='';
  int cp,i,founded;
  int nSelectIndex=0;
  HWND hWndCP=NULL;
  char szCpString[16];
  CPINFOEX CPInfoEx;

  switch(message)
  {
    case WM_INITDIALOG:
      SendMessage(hDlg,WM_SETICON,(WPARAM)ICON_BIG,(LPARAM)API_LoadIcon(hLangLib,MAKEINTRESOURCE(IDI_ICON1)));
      hWndCP=GetDlgItem(hDlg,IDC_CODEPAGE);
      EnumSystemCodePages(EnumCodePagesProc,CP_INSTALLED);
      codepages[65000]=FALSE;
      codepages[65001]=FALSE;

      for (i=0, founded=0; i <= 65535; i++)
      {
        if (codepages[i])
        {
          if (i == nCurrentCodePage) nSelectIndex=founded;
  
          if (GetCPInfoExPtr && (*GetCPInfoExPtr)(i,0,&CPInfoEx))
          {
            SendMessage(hWndCP,CB_ADDSTRING,(WPARAM)0,(LPARAM)CPInfoEx.CodePageName);
          }
          else
          {
            wsprintf(szCpString,"%d",i);
            SendMessage(hWndCP,CB_ADDSTRING,(WPARAM)0,(LPARAM)szCpString);
          }
          ++founded;
        }
      }
      SendMessage(hWndCP,CB_SETCURSEL,(WPARAM)nSelectIndex,(LPARAM)0);
      return TRUE;
    case WM_COMMAND:
      switch(LOWORD(wParam))
      {
        case IDC_CODEPAGE:
          return TRUE;
        case IDOK:
          cp=GetDlgItemInt(hDlg,IDC_CODEPAGE,NULL,FALSE);
          if (cp <= 2)
          {
            API_LoadString(hLangLib, MSG_WRONG_CODEPAGE, buf, TEMP_BUFFER_SIZE);
            MessageBox(hDlg,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
            SetFocus(hWndCP);
            SendMessage(hWndCP,EM_SETSEL,0,GetWindowTextLength(hWndCP));
          }
          else if (cp == 65000 || cp == 65001 || !MultiByteToWideChar(cp,0,&c,1,&wc,1))
          {
            API_LoadString(hLangLib, MSG_CP_UNIMPLEMENTED, buf, TEMP_BUFFER_SIZE);
            MessageBox(hDlg,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
            SetFocus(hWndCP);
            SendMessage(hWndCP,EM_SETSEL,0,GetWindowTextLength(hWndCP));
          }
          else
          {
            nDialogCP=cp;
            EndDialog(hDlg,-1);
          }
          return TRUE;
        case IDCANCEL:
          EndDialog(hDlg,0);
          return TRUE;
      }
      return FALSE;
  }
  return FALSE;
}

BOOL CALLBACK EnumCodePagesProc(LPTSTR lpCodePageString)
{
  if (lpCodePageString) codepages[xatoi(lpCodePageString)]=TRUE;
  return TRUE;
}

int FindText(HWND hWndEdit)
{
  int layout;
  int result;

  layout=SetLayout();

  if (ftflags&FR_DOWN && !(ftflags&FR_BEGINNING) && !(ftflags&FR_SELECTION))
  {
    ft.chrg.cpMin=chrg.cpMax;
    ft.chrg.cpMax=-1;
  }
  else if (ftflags&FR_UP)
  {
    ft.chrg.cpMin=chrg.cpMin;
    ft.chrg.cpMax=0;
  }
  else if (ftflags&FR_BEGINNING)
  {
    ft.chrg.cpMin=(bFirstFindReplace)?0:chrg.cpMax;
    ft.chrg.cpMax=-1;
  }
  bFirstFindReplace=FALSE;
  ft.lpstrText=org_query;

  if ((result=SendMessage(hWndEdit,EM_FINDTEXTEX,ftflags,(LPARAM)&ft)) != -1)
  {
    SendMessage(hWndEdit,EM_EXSETSEL,0,(LPARAM)&ft.chrgText);
  }

  RestoreLayout(layout);
  return result;
}

int ReplaceText(HWND hWndEdit, BOOL all)
{
  int layout;
  int result;
  int i;
  CHARRANGE crInitial;
  CHARRANGE crSelection;
  TEXTRANGE txtrng;
  int firstline;
  int currentline;

  nReplaceCount=0;
  layout=SetLayout();

  if (all)
  {
    crInitial.cpMin=chrg.cpMin;
    crInitial.cpMax=chrg.cpMax;
    firstline=SendMessage(hWndEdit,EM_GETFIRSTVISIBLELINE,0,0);
  }
  if (ftflags&FR_SELECTION)
  {
    crSelection.cpMin=chrg.cpMin;
    crSelection.cpMax=chrg.cpMax;
  }

  do
  {
    if (!((bFirstFindReplace && ftflags&FR_SELECTION) || (bFirstFindReplace && all && ftflags&FR_BEGINNING)))
    {
      txtrng.chrg.cpMin=chrg.cpMin;
      txtrng.chrg.cpMax=chrg.cpMax;

      if (txtrng.lpstrText=(char *)HeapAlloc(GetProcessHeap(),0,txtrng.chrg.cpMax - txtrng.chrg.cpMin + 1))
      {
        SendMessage(hWndEdit,EM_GETTEXTRANGE,0,(LPARAM)&txtrng);

        if ((ftflags&FR_MATCHCASE && !lstrcmp(org_query,txtrng.lpstrText)) ||
            (!(ftflags&FR_MATCHCASE) && !lstrcmpi(org_query,txtrng.lpstrText)))
        {
          ++nReplaceCount;
          SendMessage(hWndEdit,EM_REPLACESEL,TRUE,(LPARAM)org_replace);

          i=lstrlen(org_query) - lstrlen(org_replace);

          if (all)
          {
           if (crInitial.cpMin >= txtrng.chrg.cpMax) crInitial.cpMin-=i;
           else if (crInitial.cpMin < txtrng.chrg.cpMax && crInitial.cpMin > txtrng.chrg.cpMin) crInitial.cpMin=txtrng.chrg.cpMin;

           if (crInitial.cpMax >= txtrng.chrg.cpMax) crInitial.cpMax-=i;
           else if (crInitial.cpMax < txtrng.chrg.cpMax && crInitial.cpMax > txtrng.chrg.cpMin) crInitial.cpMax=nPosition;
          }
          if (ftflags&FR_UP) SendMessage(hWndEdit,EM_SETSEL,txtrng.chrg.cpMin,txtrng.chrg.cpMin);
          if (ftflags&FR_SELECTION) crSelection.cpMax-=i;
        }
        HeapFree(GetProcessHeap(),0,(LPVOID)txtrng.lpstrText);
      }
      else
      {
        API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY, buf, TEMP_BUFFER_SIZE);
        MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
        return -1;
      }
    }

    if (ftflags&FR_SELECTION)
    {
      ft.chrg.cpMin=(bFirstFindReplace)?crSelection.cpMin:chrg.cpMax;
      ft.chrg.cpMax=crSelection.cpMax;
    }
    else
    {
      if (ftflags&FR_DOWN && !(ftflags&FR_BEGINNING))
      {
        ft.chrg.cpMin=chrg.cpMax;
        ft.chrg.cpMax=-1;
      }
      else if (ftflags&FR_UP)
      {
        ft.chrg.cpMin=chrg.cpMin;
        ft.chrg.cpMax=0;
      }
      else if (ftflags&FR_BEGINNING)
      {
        ft.chrg.cpMin=(bFirstFindReplace)?0:chrg.cpMax;
        ft.chrg.cpMax=-1;
      }
    }
    bFirstFindReplace=FALSE;
    ft.lpstrText=org_query;

    if ((result=SendMessage(hWndEdit,EM_FINDTEXTEX,ftflags,(LPARAM)&ft)) != -1)
      SendMessage(hWndEdit,EM_EXSETSEL,0,(LPARAM)&ft.chrgText);
  }
  while (all && result != -1);

  if (all)
  {
    bFirstFindReplace=TRUE;
    SendMessage(hWndEdit,EM_EXSETSEL,0,(LPARAM)&crInitial);
    currentline=SendMessage(hWndEdit,EM_GETFIRSTVISIBLELINE,0,0);
    SendMessage(hWndEdit,EM_LINESCROLL,0,firstline - currentline);
  }
  RestoreLayout(layout);
  return result;
}

BOOL TranslateBackslashes(char *a)
{
  char *b=a;
  char *c=a;
  char hex[2];

  for (hex[2]='\0'; *c; ++b, ++c)
  {
    if (*c == '\\')
    {
      if (*++c == '\\') *b='\\';
      else if (*c == 'n') *b='\r';
      else if (*c == 't') *b='\t';
      else
      {
        hex[0]=*c;
        if (*c == 0) goto Error;
        hex[1]=*++c;
        if (*c == 0) goto Error;
        *b=hex2dec(hex);
        if (*b == 0) goto Error;
      }
    }
    else *b=*c;
  }
  *b='\0';
  return TRUE;

  Error:
  *a='\0';
  return FALSE;
}

BOOL CALLBACK FindAndReplaceDlgProc(HWND hDlg,UINT msg,WPARAM wParam,LPARAM lParam)
{
  static HWND hWndText, hWndNewText, hWndEdit, hWndFindNext, hFocus;
  int characters;
  int characters_new;
  int result;
  BOOL enable=TRUE;
  BOOL replace=FALSE;
  BOOL replace_all=FALSE;

  switch(msg)
  {
    case WM_INITDIALOG:
      SendMessage(hDlg,WM_SETICON,(WPARAM)ICON_BIG,(LPARAM)API_LoadIcon(hLangLib,MAKEINTRESOURCE(IDI_ICON1)));
      bFirstFindReplace=TRUE;
      hWndEdit=(HWND)lParam;
      hWndFindNext=GetDlgItem(hDlg,IDC_FINDNEXT);
      hWndText=GetDlgItem(hDlg,IDC_TEXT);
      if (bReplaceDlg == TRUE) hWndNewText=GetDlgItem(hDlg,IDC_NEWTEXT);

      if (chrg.cpMin == chrg.cpMax)
      {
        if (org_query) SetWindowText(hWndText,org_query);
      }
      else
      {
        TEXTRANGE txtrng;
        int minline;
        int maxline;
        int layout;

        txtrng.chrg.cpMin=chrg.cpMin;
        txtrng.chrg.cpMax=chrg.cpMax;
        minline=SendMessage(hWndEdit,EM_LINEFROMCHAR,txtrng.chrg.cpMin,0);
        maxline=SendMessage(hWndEdit,EM_LINEFROMCHAR,txtrng.chrg.cpMax,0);

        if (minline != maxline)
          txtrng.chrg.cpMax=SendMessage(hWndEdit,EM_LINEINDEX,minline,0) + SendMessage(hWndEdit,EM_LINELENGTH,txtrng.chrg.cpMin,0);

        if (txtrng.chrg.cpMin != txtrng.chrg.cpMax &&
            (txtrng.lpstrText=(char *)HeapAlloc(GetProcessHeap(),0,txtrng.chrg.cpMax - txtrng.chrg.cpMin + 1)))
        {
          layout=SetLayout();
          SendMessage(hWndEdit,EM_GETTEXTRANGE,0,(LPARAM)&txtrng);
          RestoreLayout(layout);

          SetWindowText(hWndText,txtrng.lpstrText);
          HeapFree(GetProcessHeap(),0,(LPVOID)txtrng.lpstrText);
        }
        else SetWindowText(hWndText,"");
      }

      if (bReplaceDlg == TRUE && org_replace) SetWindowText(hWndNewText,org_replace);

      SendMessage(GetDlgItem(hDlg,IDC_FORWARD),BM_SETCHECK,BST_UNCHECKED,0);
      SendMessage(GetDlgItem(hDlg,IDC_BACKWARD),BM_SETCHECK,BST_UNCHECKED,0);
      SendMessage(GetDlgItem(hDlg,IDC_BEGINNING),BM_SETCHECK,BST_UNCHECKED,0);
      if (bReplaceDlg == TRUE)
      {
        SendMessage(GetDlgItem(hDlg,IDC_INSEL),BM_SETCHECK,BST_UNCHECKED,0);
        EnableWindow(hWndFindNext,TRUE);
        EnableWindow(GetDlgItem(hDlg,IDC_REPLACE),TRUE);
      }
      if (ftflags&FR_DOWN && !(ftflags&FR_BEGINNING) && !(ftflags&FR_SELECTION))
        SendMessage(GetDlgItem(hDlg,IDC_FORWARD),BM_SETCHECK,BST_CHECKED,0);
      else if (ftflags&FR_UP)
        SendMessage(GetDlgItem(hDlg,IDC_BACKWARD),BM_SETCHECK,BST_CHECKED,0);
      else if (ftflags&FR_BEGINNING)
        SendMessage(GetDlgItem(hDlg,IDC_BEGINNING),BM_SETCHECK,BST_CHECKED,0);
      else if (bReplaceDlg == TRUE && ftflags&FR_SELECTION)
      {
        SendMessage(GetDlgItem(hDlg,IDC_INSEL),BM_SETCHECK,BST_CHECKED,0);
        EnableWindow(hWndFindNext,FALSE);
        EnableWindow(GetDlgItem(hDlg,IDC_REPLACE),FALSE);
      }
      SendMessage(GetDlgItem(hDlg,IDC_MATCHCASE),BM_SETCHECK,(BOOL)(ftflags&FR_MATCHCASE),0);
      SendMessage(GetDlgItem(hDlg,IDC_WHOLEWORD),BM_SETCHECK,(BOOL)(ftflags&FR_WHOLEWORD),0);
      SendMessage(GetDlgItem(hDlg,IDC_ESCAPESEQ),BM_SETCHECK,(BOOL)(ftflags&FR_ESCAPESEQ),0);
      break;

    case WM_COMMAND:
      switch(LOWORD(wParam))
      {
        case IDC_NEWTEXT:
        case IDC_MATCHCASE:
        case IDC_WHOLEWORD:
        case IDC_ESCAPESEQ:
          return TRUE;
        case IDC_FORWARD:
        case IDC_BACKWARD:
        case IDC_BEGINNING:
          if (SendMessage(GetDlgItem(hDlg,IDC_BEGINNING),BM_GETCHECK,0,0)) bFirstFindReplace=TRUE;
        case IDC_INSEL:
          if (SendMessage(GetDlgItem(hDlg,IDC_INSEL),BM_GETCHECK,0,0)) bFirstFindReplace=TRUE;
        case IDC_TEXT:
          EnableWindow(hWndFindNext,TRUE);
          if (bReplaceDlg == TRUE)
          {
            EnableWindow(GetDlgItem(hDlg,IDC_REPLACE),TRUE);
            EnableWindow(GetDlgItem(hDlg,IDC_ALL),TRUE);
          }

          if (GetWindowTextLength(hWndText) == 0)
          {
            EnableWindow(hWndFindNext,FALSE);
            if (bReplaceDlg == TRUE)
            {
              EnableWindow(GetDlgItem(hDlg,IDC_REPLACE),FALSE);
              EnableWindow(GetDlgItem(hDlg,IDC_ALL),FALSE);
            }
          }
          else if (bReplaceDlg == TRUE && SendMessage(GetDlgItem(hDlg,IDC_INSEL),BM_GETCHECK,0,0))
          {
            EnableWindow(hWndFindNext,FALSE);
            EnableWindow(GetDlgItem(hDlg,IDC_REPLACE),FALSE);
          }
          return TRUE;
        case IDCANCEL:
          DestroyWindow(hDlg);
          hDlgModeless=NULL;
          return TRUE;
        case IDC_REPLACE:
          replace=TRUE;
        case IDC_ALL:
          if (!replace) replace_all=TRUE;
        case IDC_FINDNEXT:
          FreeMemory();
          characters=GetWindowTextLength(hWndText);
          if (bReplaceDlg == TRUE) characters_new=GetWindowTextLength(hWndNewText);

          if ((org_query=(char *)HeapAlloc(GetProcessHeap(),0,characters+1)) &&
              (bReplaceDlg == FALSE || (org_replace=(char *)HeapAlloc(GetProcessHeap(),0,characters_new+1))))
          {
            GetWindowText(hWndText,org_query,characters+1);
            if (bReplaceDlg == TRUE) GetWindowText(hWndNewText,org_replace,characters_new+1);

            ftflags=0;
            if (SendMessage(GetDlgItem(hDlg,IDC_FORWARD),BM_GETCHECK,0,0)) ftflags|=FR_DOWN;
            if (SendMessage(GetDlgItem(hDlg,IDC_BACKWARD),BM_GETCHECK,0,0)) ftflags|=FR_UP;
            if (SendMessage(GetDlgItem(hDlg,IDC_BEGINNING),BM_GETCHECK,0,0)) ftflags|=FR_DOWN|FR_BEGINNING;
            if (SendMessage(GetDlgItem(hDlg,IDC_INSEL),BM_GETCHECK,0,0)) ftflags|=FR_DOWN|FR_SELECTION;
            if (SendMessage(GetDlgItem(hDlg,IDC_MATCHCASE),BM_GETCHECK,0,0)) ftflags|=FR_MATCHCASE;
            if (SendMessage(GetDlgItem(hDlg,IDC_WHOLEWORD),BM_GETCHECK,0,0)) ftflags|=FR_WHOLEWORD;

            if (SendMessage(GetDlgItem(hDlg,IDC_ESCAPESEQ),BM_GETCHECK,0,0))
            {
              ftflags|=FR_ESCAPESEQ;

              if (!TranslateBackslashes(org_query) ||
                  (bReplaceDlg == TRUE && !TranslateBackslashes(org_replace)))
              {
                API_LoadString(hLangLib, MSG_ERROR_SYNTAX, buf, TEMP_BUFFER_SIZE);
                MessageBox(hDlg,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
                return TRUE;
              }
            }
            else ftflags&=~FR_ESCAPESEQ;

            hFocus=GetFocus();
            SetFocus(hWndEdit);
            if (bReplaceDlg == TRUE && (replace == TRUE || replace_all == TRUE))
              result=ReplaceText(hWndEdit, replace_all);
            else
              result=FindText(hWndEdit);

            if (replace_all == TRUE)
            {
              API_LoadString(hLangLib, MSG_REPLACE_COUNT, buf, TEMP_BUFFER_SIZE);
              wsprintf(buf2, buf, nReplaceCount);
              MessageBox(hDlg,buf2,APP_SHORT_TITLE,MB_OK|MB_ICONINFORMATION);
            }
            else if (result == -1)
            {
              API_LoadString(hLangLib, MSG_SEARCH_ENDED, buf, TEMP_BUFFER_SIZE);
              MessageBox(hDlg,buf,APP_SHORT_TITLE,MB_OK|MB_ICONINFORMATION);
            }
            SetFocus(hFocus);
          }
          else
          {
            API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY, buf, TEMP_BUFFER_SIZE);
            MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
            FreeMemory();
          }
          break;
      }
      return TRUE;
  }
  return FALSE;
}

BOOL CALLBACK GoToLineDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndEdit;
  int line,column;
  int linenumber;
  int newline;
  int newlinelen;
  CHARRANGE selrng;

  switch(message)
  {
    case WM_INITDIALOG:
      SendMessage(hDlg,WM_SETICON,(WPARAM)ICON_BIG,(LPARAM)API_LoadIcon(hLangLib,MAKEINTRESOURCE(IDI_ICON1)));
      hWndEdit=(HWND)lParam;

      line=SendMessage(hWndEdit,EM_EXLINEFROMCHAR,0,nPosition)+1;
      SetDlgItemInt(hDlg,IDC_GOTOLINE,line,FALSE);
      return TRUE;

    case WM_COMMAND:
      switch(LOWORD(wParam))
      {
        case IDC_GOTOLINE:
          return TRUE;

        case IDOK:
          linenumber=GetDlgItemInt(hDlg,IDC_GOTOLINE,NULL,TRUE);

          if (!linenumber)
          {
            API_LoadString(hLangLib, MSG_WRONG_STRING, buf, TEMP_BUFFER_SIZE);
            MessageBox(hDlg,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
            return FALSE;
          }
          else if (linenumber < 0)
          {
            linenumber=SendMessage(hWndEdit,EM_GETLINECOUNT,0,0) + linenumber + 1;
            if (linenumber <= 0) linenumber=1;
          }

          line=SendMessage(hWndEdit,EM_EXLINEFROMCHAR,0,nPosition)+1;
          column=SendMessage(hWndEdit,EM_LINEINDEX,line-1,0);
          column=nPosition-column+1;
          newline=SendMessage(hWndEdit,EM_LINEINDEX,linenumber-1,0);
          if (newline == -1) newline=SendMessage(hWndEdit,EM_LINEINDEX,SendMessage(hWndEdit,EM_GETLINECOUNT,0,0)-1,0);
          newlinelen=SendMessage(hWndEdit,EM_LINELENGTH,newline,0);

          if (column <= newlinelen) newline+=column-1;
          else newline+=newlinelen;
          selrng.cpMin=selrng.cpMax=newline;
          SendMessage(hWndEdit,EM_EXSETSEL,0,(LPARAM)&selrng);

        case IDCANCEL:
          DestroyWindow(hDlg);
          hDlgModeless=NULL;
          return TRUE;
      }
  }
  return FALSE;
}

BOOL CALLBACK AboutDlgProc(HWND hDlg,UINT msg,WPARAM wParam,LPARAM lParam)
{
  if (msg == WM_INITDIALOG)
  {
    SendMessage(hDlg,WM_SETICON,(WPARAM)ICON_BIG,(LPARAM)API_LoadIcon(hLangLib,MAKEINTRESOURCE(IDI_ICON1)));
    SetDlgItemText(hDlg,IDC_ABOUT_EMAIL_KUZNETSOV,"developer@akelpad.net.ru");
    SetDlgItemText(hDlg,IDC_ABOUT_ICQ_KUZNETSOV,"109590531");
    SetDlgItemText(hDlg,IDC_ABOUT_EMAIL_SHENGALTS,"shengalts@mail.ru");
  }
  if (msg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
    {
      EndDialog(hDlg,0);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_HOMEPAGE)
    {
      API_LoadString(hLangLib, STR_HOMEPAGE, buf, TEMP_BUFFER_SIZE);
      ShellExecute(GetParent(hDlg),"open",buf,NULL,NULL,SW_MAXIMIZE);
    }
  }
  return FALSE;
}

BOOL isInDelimiterList(wchar_t c)
{
  return (wcschr(wszDelimiters,c) != NULL ||
          wcschr(wszWhitespace,c) != NULL ||
          wcschr(wszLinebreakers,c) != NULL);
}

int CALLBACK MyEditWordBreakProc(LPTSTR pchText, int ichCurrent, int cch, int code)
{
  int lRet=0;
  wchar_t *pchTextW=(wchar_t *)pchText;
  int cchW=cch/2;

  switch (code)
  {
    case WB_LEFTBREAK:
    case WB_MOVEWORDLEFT:
      // Finds the next character that begins a word before the specified position.
      {
        if (bFirstWordBreak)
        {
          do
            --ichCurrent;
          while (isInDelimiterList(pchTextW[ichCurrent]));
        }

        for (--ichCurrent; ichCurrent >= 0 && !isInDelimiterList(pchTextW[ichCurrent]); --ichCurrent);

        if (ichCurrent >= 0)
        {
          bFirstWordBreak=TRUE;
          lRet=ichCurrent+1;
        }
        else
        {
          bFirstWordBreak=FALSE;
          lRet=-1;
        }
      }
      break;
    case WB_MOVEWORDRIGHT:
      //Finds the next character that ends a word after the specified position.
      {
        if (bFirstWordBreak)
        {
          while (isInDelimiterList(pchTextW[ichCurrent]))
            ++ichCurrent;
          ++ichCurrent;
        }

        while (ichCurrent < cchW && !isInDelimiterList(pchTextW[ichCurrent]))
          ++ichCurrent;

        if (ichCurrent < cchW)
        {
          bFirstWordBreak=TRUE;
          lRet=ichCurrent;
        }
        else
        {
          bFirstWordBreak=FALSE;
          lRet=-1;
        }
      }
      break;
    case WB_CLASSIFY:
      //Retrieves the character class and word break flags of the character at the specified position.
      {
        if (!isInDelimiterList(pchTextW[ichCurrent]))
          lRet=WBF_ISWHITE; //WBF_BREAKAFTER|WBF_BREAKLINE;
        else
          lRet=-1;
      }
      break;
  }
  return lRet;
}

void OpenDocument(HWND hWndEdit)
{
  HANDLE hFile;
  EDITSTREAM es;
  WIN32_FIND_DATA w32fdInfo;
  int i;
  DWORD dwCount;
  DWORD dwBytesRead;
  unsigned char byteReadBuffer[DETECTBINARY];
  char *p;

  bUnixNewLine=FALSE;
  bNewLineDetected=FALSE;

  firsttime=TRUE;

  if (!FileExists(ofn.lpstrFile))
  {
    API_LoadString(hLangLib, MSG_FILE_DOES_NOT_EXIST, buf, TEMP_BUFFER_SIZE);
    wsprintf(buf2, buf, ofn.lpstrFile);
    if (MessageBox(hMainWnd,buf2, APP_SHORT_TITLE,MB_OKCANCEL|MB_ICONEXCLAMATION) == IDCANCEL)
    {
      ofn.lpstrFile[0]='\0';
      return;
    }
  }

  hFile=CreateFile(ofn.lpstrFile,
                   GENERIC_READ,
                   FILE_SHARE_READ|FILE_SHARE_WRITE,
                   NULL,
                   OPEN_ALWAYS,
                   FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,
                   NULL);

  if (hFile == INVALID_HANDLE_VALUE)
  {
    ofn.lpstrFile[0]='\0';
    API_LoadString(hLangLib, MSG_ERROR_CANNOT_OPEN_FILE, buf, TEMP_BUFFER_SIZE);
    MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
    return;
  }

  //Is it a binary file?
  if (!ReadFile(hFile,byteReadBuffer,DETECTBINARY,&dwBytesRead,NULL))
  {
    ofn.lpstrFile[0]='\0';
    API_LoadString(hLangLib, MSG_ERROR_IO, buf, TEMP_BUFFER_SIZE);
    MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
    return;
  }
  SetFilePointer(hFile,0,NULL,FILE_BEGIN);
  if (dwBytesRead)
  {
    for (dwCount=0, --dwBytesRead; dwCount < dwBytesRead; ++dwCount)
    {
      if (byteReadBuffer[dwCount] == 0x00 && byteReadBuffer[dwCount + 1] == 0x00)
      {
        API_LoadString(hLangLib, MSG_ERROR_BINARY, buf, TEMP_BUFFER_SIZE);
        wsprintf(buf2, buf, ofn.lpstrFile);
        if (MessageBox(hMainWnd,buf2,APP_SHORT_TITLE,MB_OKCANCEL|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDCANCEL)
        {
          ofn.lpstrFile[0]='\0';
          return;
        }
        break;
      }
    }
  }
  if (bNeedAutodetect)
  {
    if (!ReadFile(hFile,pcReadBuffer,AUTODETECTSIZE,&dwBytesRead,NULL))
    {
      ofn.lpstrFile[0]='\0';
      API_LoadString(hLangLib, MSG_ERROR_IO, buf, TEMP_BUFFER_SIZE);
      MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
      return;
    }
    AutodetectCodePage((unsigned char *)pcReadBuffer,dwBytesRead);
    SetFilePointer(hFile,0,NULL,FILE_BEGIN);
    bNeedAutodetect=FALSE;
  }

  es.dwCookie=(DWORD)hFile;
  es.pfnCallback=(nCurrentCodePage == nAnsiCodePage)?DummyInputStreamCallback:InputStreamCallback;

  HideCaret(NULL);

  if (nCurrentCodePage == nAnsiCodePage) SendMessage(hWndEdit,EM_STREAMIN,SF_TEXT,(LPARAM)&es);
  else SendMessage(hWndEdit,EM_STREAMIN,SF_TEXT|SF_UNICODE,(LPARAM)&es);
  SetModify(FALSE);

  ShowCaret(NULL);

  CloseHandle(hFile);

  //Set caption of synchronizing window
  if (GetFullPathName(ofn.lpstrFile,MAX_PATH,buf,&p))
  {
    SetWindowText(hSyncWindow,buf);
  }

  hFile=FindFirstFile(ofn.lpstrFile,&w32fdInfo);
  FindClose(hFile);

  wsprintf(buf,"%s - %s",(hFile != INVALID_HANDLE_VALUE)?w32fdInfo.cFileName:ofn.lpstrFile,APP_SHORT_TITLE);

  SetWindowText(hMainWnd,buf);

  if (bGlobalPrint)
  {
    DoFilePrint(hWndEdit);
    DestroyWindow(hMainWnd);
  }

  for (i=0; i < RECENTFILES; ++i)
  {
    if (!lstrcmpi(ofn.lpstrFile,szRecentNames[i]))
    {
      CHARRANGE selrng;
      selrng.cpMin=selrng.cpMax=szRecentPositions[i];
      SendMessage(hWndEdit,EM_EXSETSEL,0,(LPARAM)&selrng);
      break;
    }
  }

  AddLastFilePosition(hWndEdit);
  RecentFilesMenu(hWndEdit);
}

void SaveDocument(HWND hWndEdit)
{
  DWORD dwAttr;
  EDITSTREAM es;
  HANDLE hFile;
  WIN32_FIND_DATA w32fdInfo;
  int nChoice;

  if ((nCurrentCodePage == CP_UNICODE_UCS2_LE || nCurrentCodePage == CP_UNICODE_UCS2_BE || nCurrentCodePage == CP_UNICODE_UTF8) && !bAppendHeader)
  {
    API_LoadString(hLangLib, MSG_WHETHER_APPEND_HEADER, buf, TEMP_BUFFER_SIZE);
    API_LoadString(hLangLib, MSG_TITLE_SAVING_IN_UNICODE, buf2, TEMP_BUFFER_SIZE);
    nChoice=MessageBox(hMainWnd,buf,buf2,MB_YESNOCANCEL|MB_ICONQUESTION);
    if (nChoice == IDCANCEL) return;
    else if (nChoice == IDYES) bAppendHeader=TRUE;
  }

  firsttime=TRUE;

  dwAttr=GetFileAttributes(ofn.lpstrFile);
  if (dwAttr != 0xFFFFFFFF)
  {
    if (dwAttr&FILE_ATTRIBUTE_READONLY || dwAttr&FILE_ATTRIBUTE_HIDDEN || dwAttr&FILE_ATTRIBUTE_SYSTEM)
      SetFileAttributes(ofn.lpstrFile,(dwAttr&(!FILE_ATTRIBUTE_READONLY)&(!FILE_ATTRIBUTE_HIDDEN)&(!FILE_ATTRIBUTE_SYSTEM)));
    if (bSaveTime)
    {
      if ((hFile=FindFirstFile(ofn.lpstrFile,&w32fdInfo)) != INVALID_HANDLE_VALUE)
        FindClose(hFile);
    }
  }

  hFile=CreateFile(ofn.lpstrFile,
                   GENERIC_WRITE,
                   FILE_SHARE_READ,
                   NULL,
                   CREATE_ALWAYS,
                   FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,
                   NULL);

  if (hFile == INVALID_HANDLE_VALUE)
  {
    API_LoadString(hLangLib, MSG_ERROR_CANNOT_OPEN_FILE, buf, TEMP_BUFFER_SIZE);
    MessageBox(hMainWnd,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
    if (dwAttr != 0xFFFFFFFF) SetFileAttributes(ofn.lpstrFile,dwAttr);
    return;
  }

  es.dwCookie=(DWORD)hFile;
  es.pfnCallback=(nCurrentCodePage == nAnsiCodePage && !bUnixNewLine)?DummyOutputStreamCallback:OutputStreamCallback;

  if (nCurrentCodePage == nAnsiCodePage && !bUnixNewLine)
    SendMessage(hWndEdit,EM_STREAMOUT,SF_TEXT,(LPARAM)&es);
  else
    SendMessage(hWndEdit,EM_STREAMOUT,SF_TEXT|SF_UNICODE,(LPARAM)&es);
  SetModify(FALSE);

  CloseHandle(hFile);

  if (dwAttr != 0xFFFFFFFF)
  {
    SetFileAttributes(ofn.lpstrFile,dwAttr);
    if (bSaveTime)
    {
      if ((hFile=CreateFile(ofn.lpstrFile, FILE_WRITE_ATTRIBUTES, 0, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL)) != INVALID_HANDLE_VALUE)
      {
        SetFileTime(hFile, NULL, NULL, &w32fdInfo.ftLastWriteTime);
        CloseHandle(hFile);
      }
    }
  }

  if ((hFile=FindFirstFile(ofn.lpstrFile,&w32fdInfo)) != INVALID_HANDLE_VALUE)
    FindClose(hFile);

  wsprintf(buf,"%s - %s",w32fdInfo.cFileName,APP_SHORT_TITLE);
  SetWindowText(hMainWnd,buf);

  AddLastFilePosition(hWndEdit);
  RecentFilesMenu(hWndEdit);
}

BOOL RestorePreOptionsFromRegistry()
{
  HKEY hKey;
  DWORD dwType, dwSize;

  szLangModule[0]='\0';
  lpMainWindowRect.left=CW_USEDEFAULT;
  lpMainWindowRect.top=CW_USEDEFAULT;
  lpMainWindowRect.right=CW_USEDEFAULT;
  lpMainWindowRect.bottom=CW_USEDEFAULT;

  if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return FALSE;

  dwSize=MAX_PATH;
  RegQueryValueEx(hKey, "Language_module", NULL, &dwType, (LPBYTE)&szLangModule, &dwSize);

  dwSize=sizeof(int);
  RegQueryValueEx(hKey, "window_left", NULL, &dwType, (LPBYTE)&lpMainWindowRect.left, &dwSize);

  dwSize=sizeof(int);
  RegQueryValueEx(hKey, "window_top", NULL, &dwType, (LPBYTE)&lpMainWindowRect.top, &dwSize);

  dwSize=sizeof(int);
  RegQueryValueEx(hKey, "window_right", NULL, &dwType, (LPBYTE)&lpMainWindowRect.right, &dwSize);

  dwSize=sizeof(int);
  RegQueryValueEx(hKey, "window_bottom", NULL, &dwType, (LPBYTE)&lpMainWindowRect.bottom, &dwSize);

  RegCloseKey(hKey);
  return TRUE;
}

BOOL RestoreOptionsFromRegistry(HWND hWndEdit)
{
  HKEY hKey;
  DWORD dwType, dwValue, dwSize;

  if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return FALSE;

  dwSize=sizeof(DWORD);
  if (RegQueryValueEx(hKey, "Wrap", NULL, &dwType, (LPBYTE)&dwValue, &dwSize) == ERROR_SUCCESS)
    if (dwType == REG_DWORD && dwValue) DoEditWrap(hWndEdit);

  dwSize=sizeof(DWORD);
  if (RegQueryValueEx(hKey, "Save_time", NULL, &dwType, (LPBYTE)&dwValue, &dwSize) == ERROR_SUCCESS)
    if (dwType == REG_DWORD && dwValue) DoSettingsSaveTime(hWndEdit);

  dwSize=sizeof(DWORD);
  if (RegQueryValueEx(hKey, "Open_in_new_window", NULL, &dwType, (LPBYTE)&dwValue, &dwSize) == ERROR_SUCCESS)
    if (dwType == REG_DWORD && !dwValue) DoSettingsNoMultiOpen(hWndEdit);

  dwSize=sizeof(DWORD);
  if (RegQueryValueEx(hKey, "On_top", NULL, &dwType, (LPBYTE)&dwValue, &dwSize) == ERROR_SUCCESS)
    if (dwType == REG_DWORD && dwValue) DoSettingsOnTop(hWndEdit);

  dwSize=sizeof(DWORD);
  if (RegQueryValueEx(hKey, "Search_options", NULL, &dwType, (LPBYTE)&dwValue, &dwSize) == ERROR_SUCCESS)
    if (dwType == REG_DWORD) ftflags=dwValue;

  dwSize=sizeof(DWORD);
  if (RegQueryValueEx(hKey, "Keepspaces", NULL, &dwType, (LPBYTE)&dwValue, &dwSize) == ERROR_SUCCESS)
    if (dwType == REG_DWORD && dwValue) DoEditKeepSpace(hWndEdit);

  dwSize=sizeof(DWORD);
  if (RegQueryValueEx(hKey, "Style", NULL, &dwType, (LPBYTE)&dwValue, &dwSize) == ERROR_SUCCESS)
    if (dwType == REG_DWORD && dwValue) nCmdShow|=SW_MAXIMIZE;

  dwSize=sizeof(LOGFONT);
  if (RegQueryValueEx(hKey, "Font", NULL, &dwType, (LPBYTE)&logfont, &dwSize) == ERROR_SUCCESS)
    if (dwType == REG_BINARY && dwSize == sizeof(LOGFONT)) SetChosenFont(hWndEdit);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "Textcolor", NULL, &dwType, (LPBYTE)&cf.rgbColors, &dwSize);

  dwSize=sizeof(RECT);
  RegQueryValueEx(hKey, "Margins", NULL, &dwType, (LPBYTE)&psdPage.rtMargin, &dwSize);

  dwSize=sizeof(DWORD);
  if (RegQueryValueEx(hKey, "Background", NULL, &dwType, (LPBYTE)&cc.rgbResult, &dwSize) == ERROR_SUCCESS)
  {
    if (dwType == REG_DWORD)
    {
      SendMessage(hWndEdit,EM_SETBKGNDCOLOR,0,cc.rgbResult);
      bUseSystemBckgColor=FALSE;
    }
  }

  if (RegQueryValueEx(hKey, "Search_query", NULL, &dwType, (LPBYTE)NULL, &dwSize) == ERROR_SUCCESS)
  {
    if (dwType == REG_SZ && dwSize > 1)
    {
      if (org_query=(char *)HeapAlloc(GetProcessHeap(),0,dwSize))
      {
        if (RegQueryValueEx(hKey, "Search_query", NULL, &dwType, (LPBYTE)org_query, &dwSize) != ERROR_SUCCESS)
        {
          HeapFree(GetProcessHeap(),0,(LPVOID)org_query);
          org_query=NULL;
        }
      }
      else
      {
        API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY, buf, TEMP_BUFFER_SIZE);
        MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
      }
    }
  }

  if (RegQueryValueEx(hKey, "Replace_string", NULL, &dwType, (LPBYTE)NULL, &dwSize) == ERROR_SUCCESS)
  {
    if (dwType == REG_SZ && dwSize > 1)
    {
      if (org_replace=(char *)HeapAlloc(GetProcessHeap(),0,dwSize))
      {
        if (RegQueryValueEx(hKey, "Replace_string", NULL, &dwType, (LPBYTE)org_replace, &dwSize) != ERROR_SUCCESS)
        {
          HeapFree(GetProcessHeap(),0,(LPVOID)org_replace);
          org_replace=NULL;
        }
      }
      else
      {
        API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY, buf, TEMP_BUFFER_SIZE);
        MessageBox(NULL,buf,APP_SHORT_TITLE,MB_OK|MB_ICONERROR);
      }
    }
  }

  RegCloseKey(hKey);
  return TRUE;
}

BOOL SaveOptionsInRegistry(HWND hWnd)
{
  HKEY hKey;
  DWORD dwDisp,dwOne=1,dwZero=0;

  if (RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp) != ERROR_SUCCESS)
    return FALSE;

  if (RegSetValueEx(hKey, "Language_module", 0, REG_SZ, (LPBYTE)szLangModule, lstrlen(szLangModule)+1) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "Search_query", 0, REG_SZ, (LPBYTE)(org_query?org_query:""), org_query?lstrlen(org_query)+1:1) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "Replace_string", 0, REG_SZ, (LPBYTE)(org_replace?org_replace:""), org_replace?lstrlen(org_replace)+1:1) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "Search_options", 0, REG_DWORD, (LPBYTE)&ftflags, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "Save_time", 0, REG_DWORD, (LPBYTE)(bSaveTime?&dwOne:&dwZero), sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "Open_in_new_window", 0, REG_DWORD, (LPBYTE)(bOpenInNewWindow?&dwOne:&dwZero), sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "On_top", 0, REG_DWORD, (LPBYTE)(bOnTop?&dwOne:&dwZero), sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "Wrap", 0, REG_DWORD, (LPBYTE)(bWrapOn?&dwOne:&dwZero), sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "Keepspaces", 0, REG_DWORD, (LPBYTE)(bKeepOn?&dwOne:&dwZero), sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "Margins", 0, REG_BINARY, (LPBYTE)&psdPage.rtMargin, sizeof(RECT)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "Font", 0, REG_BINARY, (LPBYTE)&logfont, sizeof(LOGFONT)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "Textcolor", 0, REG_DWORD, (LPBYTE)&cf.rgbColors, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (!bUseSystemBckgColor)
  {
    if (RegSetValueEx(hKey, "Background", 0, REG_DWORD, (LPBYTE)&cc.rgbResult, sizeof(DWORD)) != ERROR_SUCCESS)
      goto Error;
  }

  if (RegSetValueEx(hKey, "Style", 0, REG_DWORD, (LPBYTE)((GetWindowLong(hWnd,GWL_STYLE)&WS_MAXIMIZE)?&dwOne:&dwZero), sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (!(GetWindowLong(hWnd,GWL_STYLE)&WS_MINIMIZE))
  {
    if (!(GetWindowLong(hWnd,GWL_STYLE)&WS_MAXIMIZE))
    {
      GetWindowRect(hWnd,&lpMainWindowRect);
      lpMainWindowRect.right-=lpMainWindowRect.left;
      lpMainWindowRect.bottom-=lpMainWindowRect.top;

      if (RegSetValueEx(hKey, "window_left", 0, REG_DWORD, (LPBYTE)&lpMainWindowRect.left, sizeof(DWORD)) != ERROR_SUCCESS)
      goto Error;

      if (RegSetValueEx(hKey, "window_top", 0, REG_DWORD, (LPBYTE)&lpMainWindowRect.top, sizeof(DWORD)) != ERROR_SUCCESS)
      goto Error;

      if (RegSetValueEx(hKey, "window_right", 0, REG_DWORD, (LPBYTE)&lpMainWindowRect.right, sizeof(DWORD)) != ERROR_SUCCESS)
      goto Error;

      if (RegSetValueEx(hKey, "window_bottom", 0, REG_DWORD, (LPBYTE)&lpMainWindowRect.bottom, sizeof(DWORD)) != ERROR_SUCCESS)
      goto Error;
    }
  }

  RegCloseKey(hKey);
  return TRUE;

  Error:
  RegCloseKey(hKey);
  return FALSE;
}

BOOL RestoreLastFilePosition(HWND hWndEdit)
{
  HKEY hKey;
  DWORD dwType, dwSize;
  int i;

  memset(szRecentNames,0,MAX_PATH*RECENTFILES);
  memset(szRecentPositions,0,RECENTFILES*sizeof(int));

  if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Recent", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return FALSE;

  for (i=0; i < RECENTFILES; ++i)
  {
    wsprintf(buf,"name%d",i);
    dwSize=MAX_PATH;
    if (RegQueryValueEx(hKey, buf, NULL, &dwType, (LPBYTE)szRecentNames[i], &dwSize) != ERROR_SUCCESS)
      break;

    wsprintf(buf,"pos%d",i);
    dwSize=sizeof(DWORD);
    RegQueryValueEx(hKey, buf, NULL, &dwType, (LPBYTE)&szRecentPositions[i], &dwSize);
  }
  RegCloseKey(hKey);

/*
  //Delete files from recent file array if they aren't exists
  for (i=0; *szRecentNames[i] && i < RECENTFILES; ++i)
  {
    while (*szRecentNames[i] && !FileExists(szRecentNames[i]))
    {
      for (a=i; a < RECENTFILES-1; ++a)
      {
        lstrcpy(szRecentNames[a],szRecentNames[a+1]);
        szRecentPositions[a]=szRecentPositions[a+1];
      }
      *szRecentNames[RECENTFILES-1]='\0';
      szRecentPositions[RECENTFILES-1]=0;
    }
  }
*/
  return TRUE;
}

BOOL AddLastFilePosition(HWND hWndEdit)
{
  int i=0;

  if (!*ofn.lpstrFile) return FALSE;

  while (i < RECENTFILES)
    if (!lstrcmpi(szRecentNames[i++],ofn.lpstrFile)) break;

  if (--i)
    for (; i >= 0; --i)
    {
      lstrcpy(szRecentNames[i],szRecentNames[i-1]);
      szRecentPositions[i]=szRecentPositions[i-1];
    }
  lstrcpy(szRecentNames[0],ofn.lpstrFile);
  szRecentPositions[0]=nPosition;

  return TRUE;
}

BOOL SaveLastFilePosition(HWND hWndEdit)
{
  HKEY hKey;
  int i;

  if (RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Recent", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
    return FALSE;

  for (i=0; i < RECENTFILES; ++i)
  {
    wsprintf(buf,"name%d",i);
    if (RegSetValueEx(hKey, buf, 0, REG_SZ, (LPBYTE)(*szRecentNames[i]?szRecentNames[i]:""), *szRecentNames[i]?lstrlen(szRecentNames[i])+1:1) != ERROR_SUCCESS)
    {
      RegCloseKey(hKey);
      return FALSE;
    }

    wsprintf(buf,"pos%d",i);
    if (RegSetValueEx(hKey, buf, 0, REG_DWORD, (LPBYTE)&szRecentPositions[i], sizeof(DWORD)) != ERROR_SUCCESS)
    {
      RegCloseKey(hKey);
      return FALSE;
    }
  }
  RegCloseKey(hKey);
  return TRUE;
}

void RecentFilesMenu(HWND hWndEdit)
{
  int i;

  for (i=1; DeleteMenu(hMenu,IDM_RECENT_FILES+i,MF_BYCOMMAND); ++i);

  if (*szRecentNames[0])
  {
    for (i=0; *szRecentNames[i] && i < RECENTFILES; ++i)
    {
      if (*szRecentNames[i+1])
        InsertMenu(hMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_STRING, IDM_RECENT_FILES+i+1, szRecentNames[i]);
      else
        ModifyMenu(hMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_STRING, IDM_RECENT_FILES, szRecentNames[i]);
    }
  }
  else
  {
    API_LoadString(hLangLib, STR_RECENT_FILES_EMPTY, buf, TEMP_BUFFER_SIZE);
    ModifyMenu(hMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_STRING|MF_GRAYED, IDM_RECENT_FILES, buf);
  }
}

void LanguageMenu(HWND hWndEdit)
{
  WIN32_FIND_DATA wfd;
  HANDLE hFind;
  UINT uFlags;
  int i;
  nLangModules=0;

  for (i=1; DeleteMenu(hMenu,IDM_SETTINGS_LANGUAGE+i,MF_BYCOMMAND); ++i);

  //Get program directory
  i=GetModuleFileName(NULL, buf, TEMP_BUFFER_SIZE);
  while (i > 0 && buf[i] != '\\') --i;
  buf[i]='\0';
  lstrcat(buf, "\\*.dll");

  if ((hFind=FindFirstFile(buf, &wfd)) != INVALID_HANDLE_VALUE)
  {
    i=1;

    do
    {
      if (!lstrcmpi(szLangModule, wfd.cFileName))
        uFlags=MF_BYCOMMAND|MF_STRING|MF_CHECKED;
      else
        uFlags=MF_BYCOMMAND|MF_STRING|MF_UNCHECKED;
      InsertMenu(hMenu, IDM_SETTINGS_LANGUAGE, uFlags, IDM_SETTINGS_LANGUAGE+i, wfd.cFileName);
      ++i;
    }
    while (FindNextFile(hFind, &wfd));

    nLangModules=i-1;
    InsertMenu(hMenu,IDM_SETTINGS_LANGUAGE,MF_BYCOMMAND|MF_SEPARATOR, IDM_SETTINGS_LANGUAGE+i, NULL);
    FindClose(hFind);
  }

  API_LoadString(hLangLib, STR_LANGUAGE_NONE, buf, TEMP_BUFFER_SIZE);
  if (!*szLangModule)
    uFlags=MF_BYCOMMAND|MF_STRING|MF_CHECKED;
  else
    uFlags=MF_BYCOMMAND|MF_STRING|MF_UNCHECKED;
  ModifyMenu(hMenu, IDM_SETTINGS_LANGUAGE, uFlags, IDM_SETTINGS_LANGUAGE, buf);
}

BOOL FileExists(char *fname)
{
  WIN32_FIND_DATA wfd;
  HANDLE hFind=FindFirstFile(fname, &wfd);
  if (INVALID_HANDLE_VALUE != hFind)
  {
    FindClose(hFind);
    return TRUE;
  }
  return FALSE;
}

void SetChosenFont(HWND hWndEdit)
{
  HFONT hNewFont;
  RECT rEdit;
  CHARFORMAT cfmt;

  hNewFont=CreateFontIndirect(&logfont);
  SendMessage(hWndEdit,WM_SETFONT,(WPARAM)hNewFont,(LPARAM)TRUE);
  if (hCurrentFont) DeleteObject(hCurrentFont);
  hCurrentFont=hNewFont;
  SendMessage(hWndEdit,EM_SETMARGINS,EC_LEFTMARGIN|EC_RIGHTMARGIN,MAKELONG(4,4));
  if (GetClientRect(hWndEdit,&rEdit))
  {
    InvalidateRect(hWndEdit,&rEdit,FALSE);
    UpdateWindow(hWndEdit);
  }

  cfmt.cbSize=sizeof(CHARFORMAT);
  cfmt.dwMask=CFM_COLOR;
  cfmt.dwEffects=0;
  cfmt.crTextColor=cf.rgbColors;
  cfmt.bPitchAndFamily=logfont.lfPitchAndFamily;

  SendMessage(hWndEdit,EM_SETCHARFORMAT,SCF_ALL,(LPARAM)&cfmt);
}

int SetLayout()
{
  int reserv_layout=LOWORD(GetKeyboardLayout(0));
  if (reserv_layout != wSystemLanguage && !ActivateKeyboardLayout((HKL)wSystemLanguage,0))
    reserv_layout=0;
  return reserv_layout;
}

void RestoreLayout(int reserv_layout)
{
  if (reserv_layout) ActivateKeyboardLayout((HKL)reserv_layout,0);
}

BOOL GetModify()
{
  return bModified;
}

void SetModify(BOOL state)
{
  bModified=state;
  API_LoadString(hLangLib, STR_MODIFIED, buf, TEMP_BUFFER_SIZE);
  SendMessage(hStatus,SB_SETTEXT,2,(LPARAM)(bModified?buf:""));
}

void FreeMemory()
{
  if (org_query)
  {
    HeapFree(GetProcessHeap(),0,(LPVOID)org_query);
    org_query=NULL;
  }
  if (bReplaceDlg == TRUE && org_replace)
  {
    HeapFree(GetProcessHeap(),0,(LPVOID)org_replace);
    org_replace=NULL;
  }
}

BOOL DisplayCodePage(int cp)
{
  CPINFOEX CPInfoEx;

  if (cp == CP_UNICODE_UCS2_LE)
  {
    API_LoadString(hLangLib, STR_CP_UNICODE_UCS2_LE, buf, TEMP_BUFFER_SIZE);
  }
  else if (cp == CP_UNICODE_UCS2_BE)
  {
    API_LoadString(hLangLib, STR_CP_UNICODE_UCS2_BE, buf, TEMP_BUFFER_SIZE);
  }
  else if (cp == CP_UNICODE_UTF8)
  {
    API_LoadString(hLangLib, STR_CP_UNICODE_UTF8, buf, TEMP_BUFFER_SIZE);
  }
  else
  {
    if (GetCPInfoExPtr && (*GetCPInfoExPtr)(cp,0,&CPInfoEx))
      lstrcpy(buf,CPInfoEx.CodePageName);
    else
      wsprintf(buf,"CP-%u",cp);
  }

  SendMessage(hStatus,SB_SETTEXT,3,(LPARAM)buf);
  return TRUE;
}

HMENU API_LoadMenu(HINSTANCE hLoadInstance, LPCTSTR lpMenuName)
{
  HMENU hResult;

  if (!(hResult=LoadMenu(hLoadInstance, lpMenuName)))
    if (hLoadInstance != hInstance)
      hResult=LoadMenu(hInstance, lpMenuName);

  return hResult;
}

HACCEL API_LoadAccelerators(HINSTANCE hLoadInstance, LPCTSTR lpTableName)
{
  HACCEL hResult;

  if (!(hResult=LoadAccelerators(hLoadInstance, lpTableName)))
    if (hLoadInstance != hInstance)
      hResult=LoadAccelerators(hInstance, lpTableName);

  return hResult;
}

HCURSOR API_LoadCursor(HINSTANCE hLoadInstance, LPCTSTR lpCursorName)
{
  HCURSOR hResult;

  if (!(hResult=LoadCursor(hLoadInstance, lpCursorName)))
    if (hLoadInstance != hInstance)
      hResult=LoadCursor(hInstance, lpCursorName);

  return hResult;
}

HICON API_LoadIcon(HINSTANCE hLoadInstance, LPCTSTR lpIconName)
{
  HICON hResult;

  if (!(hResult=LoadIcon(hLoadInstance, lpIconName)))
    if (hLoadInstance != hInstance)
      hResult=LoadIcon(hInstance, lpIconName);

  return hResult;
}

int API_LoadString(HINSTANCE hLoadInstance, UINT uID, LPTSTR lpBuffer, int nBufferMax)
{
  int nResult;

  if (!(nResult=LoadString(hLoadInstance, uID, lpBuffer, nBufferMax)))
    if (hLoadInstance != hInstance)
      if (!(nResult=LoadString(hInstance, uID, lpBuffer, nBufferMax)))
        lpBuffer[0]='\0';

  return nResult;
}